#ifndef BUFFER_SPLIT_H
#define BUFFER_SPLIT_H

#define BUFFER_SIZE 2048
#define HUGE_MEMORY_REQUIRED 192
#include <fstream>
#include <sstream>
#include <string>

class BufferSplit {
    char *full;
    char *head;
    char *tail;
    const std::string MARGIN;
    int count, enough, MARGIN_SIZE, split;
    std::string fullLine;

public:
    ~BufferSplit() {
        delete[] full;
        delete[] head;
        delete[] tail;
    }

    bool addMargin(int s);
    bool squeezing(std::string & c, int s);
    BufferSplit(std::string & c, std::string & f, int s);
    BufferSplit(std::string & f, int s, int delete_characters, bool margin);
    int addData(std::string & data);
    int clearPart();
    std::string unified();
    void excise(int s, int d);
    void trimming(int s);
};

#endif // BUFFER_SPLIT_H
