#ifndef EDITOR_H
#define EDITOR_H

#pragma warn -8012 // Borland C++ 5.5.1 for Win32

#define VERSION 1.11
#define BALLS_BONUS 9 // LOTO_7 + 2
#define BINARY_FILE ".bin"
#define CLOSE_BUTTON_HEIGHT 30
#define CLOSE_BUTTON_WIDTH 68
#define CSV_LINE_COUNT 5000
#define EDITOR_LINE 4
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 256
#define GAP_IMAGE_COUNT 101 // IMAGE_COUNT + 1
#define GAP_SIZE 1
#define IMAGE_COUNT 100
#define IMAGE_HEIGHT 17
#define IMAGE_TOP 2
#define IMAGE_WIDTH 10
#define JUMP_BUTTON_HEIGHT 30
#define JUMP_BUTTON_WIDTH 75
#define JUMP_FIELD_HEIGHT 26
#define JUMP_FIELD_WIDTH 37
#define JUMP_PANE_HEIGHT 88
#define JUMP_PANE_WIDTH 210
#define LABEL_COUNT 20
#define LABEL_HEIGHT 17
#define LABEL_WIDTH 393
#define LARGE_BUFFER_SIZE 6016
#define LOTO_6_COUNT 43
#define LOTO_7 7
#define MAIN_HEIGHT 263
#define MAIN_WIDTH 498
#define MAIN_X 280
#define MAIN_Y 257
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT_LINE_COUNT 18
#define MAXIMUM_DATA_SIZE 39 // RECORD_SIZE - PARAMETER_COUNT - 1
#define NON_SAMPLING_PERIOD 730
#define NO_BLOCK -1 // NO_BLOCK is expressed as 0xFF in case of record[4] = NO_BLOCK.
#define PANEL_HEIGHT 17
#define PARAMETER_COUNT 10
#define RECORD_SIZE 50
#define SEE_TEXT "see.txt"
#define SEE_TEXT_LINE_COUNT 18
#define SERIAL_TEXT "serial.txt"
#define SMALL_BUFFER_SIZE 64
#define TABULATE_TEXT "tabulate.txt"
#define TEXT_Y 2
#define TRUE_TEXT "true.txt"
#define UND "und"
#define VERSION_TEXT "version.txt"
#define WHO_TEXT "who.txt"
#define WIDE_PANE 1008
#define ZOKO_PDF "zoko.pdf"
#include <fstream>
#include <map>
#include <sstream>
#include <string>
#include "BufferSplit.h"
#include "Dividing.h"
#include "NAMES.h"
#include "OS-specific.h"
#include "TimeName.h"

enum BALL_COLOR {RED, YELLOW, BEIGE, GREEN, BLUE, NAVY, PURPLE, BALL_COLOR_COUNT};
typedef std::map<std::string, int> TEXT_X;

bool removeTemporaryFiles();
int modified_file(const char *file_name);
void createErrorText(std::string & messages);
void guide(bool comments);

#endif // EDITOR_H
