#include "OS-specific.h"

bool createRemoveErrorText() {
    using namespace std;

    bool found;
    const int FILE_TYPE_COUNT = 8;
    const string e0("err*.txt");
    const string e1("pic*.txt");
    const string e2("see*.txt");
    const string e3("und*.bin");
    const string e4("who*.csv");
    const string e5("who*.txt");
    const string e6("");
    const string e7("");
    string file_type[FILE_TYPE_COUNT];
    HANDLE find_first_next_handle;
    ofstream remove_e(REMOVE_ERROR_TEXT);
    if( remove_e.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream remove_e(REMOVE_ERROR_TEXT)" << endl;
        return false;
    }

    WIN32_FIND_DATA find_data;

    file_type[0] = e0;
    file_type[1] = e1;
    file_type[2] = e2;
    file_type[3] = e3;
    file_type[4] = e4;
    file_type[5] = e5;
    file_type[6] = e6;
    file_type[7] = e7;
    for(int i = 0; i < FILE_TYPE_COUNT; ++i) {
        if( file_type[i].length() == 0 ) {
            break;
        }

        find_first_next_handle = ::FindFirstFile( file_type[i].c_str(), &find_data);
        if(find_first_next_handle == INVALID_HANDLE_VALUE) {
            continue;
        }

        found = true;
        while(found) {
            remove_e << find_data.cFileName << endl;
            found = ::FindNextFile(find_first_next_handle, &find_data);
        }

        ::FindClose(find_first_next_handle);
    }

    return true;
}

int executeProgram(const char *p, const char *q) {
    char FileName[SMALL_BUFFER_SIZE];
    char Parameters[SMALL_BUFFER_SIZE];
    strcpy(FileName, p);
    strcpy(Parameters, q);

    SHELLEXECUTEINFO execinfo;
    memset(&execinfo, 0, sizeof(execinfo) );
    execinfo.cbSize = sizeof(execinfo);
    execinfo.fMask = SEE_MASK_NOCLOSEPROCESS;
    execinfo.lpFile = FileName;
    execinfo.lpParameters = Parameters;
    execinfo.lpVerb = "open";
    execinfo.nShow = SW_SHOWDEFAULT;
    int error = (int) ::ShellExecuteEx(&execinfo);
    return error;
}

std::string currentDirectory() {
    using namespace std;

    const DWORD DIRECTORY_BUFFER_SIZE = 1024;
    char buffer[DIRECTORY_BUFFER_SIZE];
    ::GetCurrentDirectory(DIRECTORY_BUFFER_SIZE, (LPTSTR)buffer );

    string current_directory(buffer);
    return current_directory;
}
