#ifndef MARK_H
#define MARK_H

#pragma warn -8006 // Borland C++ 5.5.1 for Win32
#pragma warn -8012
#pragma warn -8018

#define VERSION 1.11
#define BALL_SET_ARRAY 3 // ballSet[][][3]
#define BALLS_BONUS 9 // LOTO_7 + 2
#define BUFFER_SIZE 2048
#define CELL_WIDTH 50
#define CLIENT_WIDTH 551
#define EDIT_FIELD_HEIGHT 28
#define EDIT_FIELD_WIDTH 381
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 256
#define IDH_MARK            109
#define IMAGE_LEFT 5
#define IMAGE_TOP 5
#define ISOCHROMATIC_BALL_COUNT 8
#define LABEL_COUNT 18
#define LABEL_HEIGHT 16
#define LOTO_6_COUNT 43
#define LOTO_7 7
#define MAIN_HEIGHT 419
#define MAIN_WIDTH 559
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT_LINE_COUNT 18
#define MARK_LINE 10
#define NON_SAMPLING_PERIOD 823
#define PLACE_COUNT 11 // BALLS_BONUS < PLACE_COUNT < FIELD_COUNT
#define REMOVE_ERROR_TEXT "remove_e.txt"
#define SEE "see"
#define SEE_TEXT "see.txt"
#define SERIAL_TEXT "serial.txt"
#define SMALL_BUFFER_SIZE 64
#define SMALL_EDIT_FIELD_WIDTH 170
#define TABULATE_TEXT "tabulate.txt"
#define TEXT_FILE ".txt"
#define TRIMMING 1
#define TRUE_TEXT "true.txt"
#define UNASSIGNED -1
#define VERSION_TEXT "version.txt"
#define WHO_TEXT "who.txt"
#define ZOKO_PDF "zoko.pdf"
#include <fstream>
#include <iostream>
#include <map>
#include <sstream>
#include <string>
#include <time.h>
#include "BallColorSet.h"
#include "Dividing.h"
#include "MarkMemo.h"
#include "NAMES.h"
#include "Numbered.h"
#include "OS-specific.h"
#include "TimeName.h"

class BallXY {
    bool black_circle;
    int circle_x, circle_y;
    std::string ball_name;

public:
    ~BallXY(){}

    bool black() const {
        return black_circle;
    }

    int ballX() const {
        return circle_x;
    }

    int ballY() const {
        return circle_y;
    }

    std::string ballName() const {
        return ball_name;
    }

    BallXY(std::string & a, int x, int y, bool b) {
        ball_name = a;
        black_circle = b;
        circle_x = x;
        circle_y = y;
    }

};

class MissingBonus {
    int b, m;
    const std::string HYPHEN;
    std::string bonus, missing, missingBonus;

    int stringToInteger(std::string & data);

public:
    ~MissingBonus(){}

    int bonusBallNumber() const {
        return b;
    }

    int missingBallNumber() const {
        return m;
    }

    std::string bonusBallName() const {
        return bonus;
    }

    std::string missingBallName() const {
        return missing;
    }

    MissingBonus(MissingBonus *mb);
    MissingBonus(std::string & bo, std::string & mi);
};

bool readFilesBeforeCreatingWindows(std::string & commandLine);
bool removeTemporaryFiles();
int modified_file(const char *file_name);
void createErrorText(std::string & messages);
void guide(bool comments);

#endif // MARK_H
