/*
Mark Version 1.11
Showing the Mark window of Zoko
Copyright 2017 Sogaya

Borland C++Builder 5

*/

#include <vcl.h>
#include "markMain.h"
#pragma hdrstop
USERES("mark.res");
USEFORM("markMain.cpp", Form1);
USEUNIT("BallColorSet.cpp");
USEUNIT("Dividing.cpp");
USEUNIT("MissingBonus.cpp");
USEUNIT("Numbered.cpp");
USEUNIT("TimeName.cpp");
USEUNIT("OS-specific.cpp");
//---------------------------------------------------------------------------
MarkMemo *mm;

namespace {
    using namespace std;

    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int STANDARD_LINE_LENGTH = 20; // "07 14 20 24 28 32 37"
    const string BEIGE_TERM = "-be";
    const string BLUE_TERM = "-bl";
    const string CLOSE_BRACKET(" )");
    const string FIRST_LINE("06 37 09 31 36 02 12 03 22 -A -214 ");
    const string GREEN_TERM = "-gr";
    const string NAVY_BLUE_TERM = "-na";
    const string NO_REMOVING = "-r-";
    const string PURPLE_TERM = "-pu";
    const string QUIT = "-q";
    const string RED_TERM = "-re";
    const string SORT = "-s";
    const string VERSION_COMMENTS = "-VC";
    const string VERSION_GUIDE = "-V";
    const string WHERE("-w");
    const string YELLOW_TERM = "-ye";
    const string Z_MISSING_BONUS = "-z";
    const string ZERO("0");

    string error("");
}

bool readFilesBeforeCreatingWindows(std::string & commandLine) {
    using namespace std;

    bool quit = false;
    bool removeFirst = true;
    bool show_where = false;
    bool sort_balls = false;
    char buffer[BUFFER_SIZE];
    char r[SMALL_BUFFER_SIZE] = "-ye37";
    Dividing d(commandLine);
    const int FIELD_COUNT = d.fieldCount();
    int q;
    int beige_number = UNASSIGNED;
    int blue_number = UNASSIGNED;
    int green_number = UNASSIGNED;
    int navy_number = UNASSIGNED;
    int purple_number = UNASSIGNED;
    int red_number = UNASSIGNED;
    int yellow_number = UNASSIGNED;
    int z_bonus_number = UNASSIGNED;
    int z_missing_number = UNASSIGNED;
    Numbered *n = new Numbered(r);
    string *firstLine = new string(FIRST_LINE);
    string argument;
    string fullPathName;
    string mark_info_yellow("Mark\\info\\markYellow.bmp");
    string who_text(WHO_TEXT);

// C:\zokoVCL\mark\info\markYellow.bmp for example
    string firstPart = currentDirectory(); // OS-specific.h and OS-specific.cpp
    NAMES a = driveDirectoryBase(firstPart);
    string SEPARATOR = a.separator;
    string root = a.name[1];
    if (firstPart == root) { // C:\ for example
        fullPathName = root + mark_info_yellow;
    } else { // C:\zokoVCL for example
        fullPathName = firstPart + SEPARATOR + mark_info_yellow;
    }

    ifstream file( fullPathName.c_str() );
    if ( file.fail() ) {
        error = "ifstream file( " + fullPathName + CLOSE_BRACKET;
    } else {
        file.close();
    }

// Acquiring firstLine from WHO_TEXT
    ifstream in(WHO_TEXT);
    if( in.fail() ) {
        error = "e1: ifstream in( " + who_text + CLOSE_BRACKET;
        delete firstLine; delete n;
        return false;
    }

    if( in.getline(buffer, BUFFER_SIZE) ) {
        delete firstLine;
        firstLine = new string(buffer);
    } else {
        error = "e3: ifstream in( " + who_text + CLOSE_BRACKET;
        delete firstLine; delete n;
        return false;
    }

    in.close();

// parameters
    for(int i = 1; i < FIELD_COUNT; ++i) {
        argument = d.a(i);
        if( argument.length() == 0 ) {
            break;
        }

        if(NO_REMOVING == argument) {
            removeFirst = false;
        } else if(QUIT == argument) {
            quit = true;
        } else if(SORT == argument) {
            sort_balls = true;
        } else if(VERSION_COMMENTS == argument) {
            guide(WITH_COMMENTS);
            delete firstLine; delete n;
            return false;

        } else if(VERSION_GUIDE == argument) {
            guide(WITHOUT_COMMENTS);
            delete firstLine; delete n;
            return false;

        } else if(WHERE == argument) {
            show_where = true;
        } else {
            q = argument.find(SORT);
            if(q != string::npos) {
                sort_balls = true;
                argument = argument.substr(0, q);
                continue;
            }

            q = argument.find(BEIGE_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                beige_number = n->number();
                if( BEIGE_TERM == n->parameter() ) {
                    continue;
                }

                beige_number = UNASSIGNED;
            }

            q = argument.find(BLUE_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                blue_number = n->number();
                if( BLUE_TERM == n->parameter() ) {
                    continue;
                }

                blue_number = UNASSIGNED;
            }

            q = argument.find(GREEN_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                green_number = n->number();
                if( GREEN_TERM == n->parameter() ) {
                    continue;
                }

                green_number = UNASSIGNED;
            }

            q = argument.find(NAVY_BLUE_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                navy_number = n->number();
                if( NAVY_BLUE_TERM == n->parameter() ) {
                    continue;
                }

                navy_number = UNASSIGNED;
            }

            q = argument.find(PURPLE_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                purple_number = n->number();
                if( PURPLE_TERM == n->parameter() ) {
                    continue;
                }

                purple_number = UNASSIGNED;
            }

            q = argument.find(RED_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                red_number = n->number();
                if( RED_TERM == n->parameter() ) {
                    continue;
                }

                red_number = UNASSIGNED;
            }

            q = argument.find(YELLOW_TERM);
            if(q != string::npos) {
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                yellow_number = n->number();
                if( YELLOW_TERM == n->parameter() ) {
                    continue;
                }

                yellow_number = UNASSIGNED;
            }

            q = argument.find(Z_MISSING_BONUS);
            if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                z_bonus_number = n->number();
                if( n->trimmed_sequence() ) {
                    z_missing_number = n->subnumber();
                    if( n->parameter() == Z_MISSING_BONUS ) {
                        continue;
                    }

                }

                z_missing_number = UNASSIGNED;
                z_bonus_number = UNASSIGNED;
            }

            delete firstLine;
            firstLine = new string(argument);
        }

    }

    if(removeFirst) {
        removeTemporaryFiles();
    }

    string line_1 = *firstLine;
    if( line_1.length() < STANDARD_LINE_LENGTH ) {
        error = "e4: \"" + line_1 + "\".length() < STANDARD_LINE_LENGTH ";
        delete firstLine; delete n;
        return false;
    }

    delete n;
    if(quit) {
        return false;
    }

    mm = new MarkMemo(line_1, fullPathName, beige_number, blue_number, green_number, navy_number, purple_number, red_number, yellow_number, z_bonus_number, z_missing_number, show_where, sort_balls);
    return true;
}

void createErrorText(std::string & messages) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << messages << endl;
}

void guide(bool comments) {
    using namespace std;

    if(comments) {
        ofstream file(VERSION_TEXT);
        file << "mark Version " << VERSION << " \n" << endl 
            << "mark          # Show the Mark window. " << endl 
            << "mark -be17    # beige ball-17 " << endl 
            << "mark -bl15    # blue ball-15 " << endl 
            << "mark -gr35    # green ball-35 " << endl 
            << "mark -na34    # navy blue ball-34 " << endl 
            << "mark -pu28    # purple ball-28 " << endl 
            << "mark -q       # Quit before showing the Mark window." << endl 
            << "mark -r-      # Do not remove temporary files. " << endl 
            << "mark -re15    # red ball-15 " << endl 
            << "mark -s       # Sort seven balls and omit bonus balls. " << endl 
            << "mark -V       # version " << endl 
            << "mark -VC      # version with comments " << endl 
            << "mark -w       # Show where the cursor is. " << endl 
            << "mark -ye23    # yellow ball-23 " << endl;
    } else {
        ofstream file(VERSION_TEXT);
        file << "mark Version " << VERSION << " \n" << endl 
            << "mark          " << endl 
            << "mark -be17    " << endl 
            << "mark -bl15    " << endl 
            << "mark -gr35    " << endl 
            << "mark -na34    " << endl 
            << "mark -pu28    " << endl 
            << "mark -q       " << endl 
            << "mark -r-      " << endl 
            << "mark -re15    " << endl 
            << "mark -s       " << endl 
            << "mark -V       " << endl 
            << "mark -VC      " << endl 
            << "mark -w       " << endl 
            << "mark -ye23    " << endl;
    }

}

bool removeTemporaryFiles() {
    using namespace std;

    bool match;
    char c[FILE_NAME_SIZE];
    ifstream in(REMOVE_ERROR_TEXT);
    if( in.fail() ) {
        return false;
    }

    while( in.getline(c, FILE_NAME_SIZE) ) {
        if( strcmp(c, SEE_TEXT) ) { // Do not remove SEE_TEXT.
            if( strcmp(c, TABULATE_TEXT) ) { // Do not remove TABULATE_TEXT.
                if( strcmp(c, TRUE_TEXT) ) { // Do not remove TRUE_TEXT.
                    if( strcmp(c, WHO_TEXT) ) { // Do not remove WHO_TEXT.
                        remove(c);
                    }

                }

            }

        }

    }

    return true;
}

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    std::string command( ::GetCommandLine() );
    if( readFilesBeforeCreatingWindows(command) ) {
        ;
    } else {
        createErrorText(error);
        return 0;
    }

    try
    {
         Application->Initialize();
         Application->Title = "Mark";
         Application->HelpFile = "C:\\zokoVCL\\ZOKO.HLP";
         Application->CreateForm(__classid(TForm1), &Form1);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}
