/*
Mark Version 1.11
Showing the Mark window of Zoko
Copyright 2017 Sogaya

Borland C++Builder 5

*/

#include <vcl.h>
#pragma hdrstop

#include "markMain.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

extern MarkMemo *mm;
TForm1 *Form1;

AnsiString TForm1::itemCaption(std::string & s, std::string & bonus, int which, int place) {
    using namespace std;

    const int Q = place * 3;
    string tail = s.substr(Q);
    string missing = tail.substr(0, 2);
    AnsiString a( missing.c_str() );
    AnsiString b( bonus.c_str() );
    AnsiString i = a + "-" + b;

    mb[which][place] = new MissingBonus(bonus, missing);
    return i;
}

bool TForm1::createSeeText() {
    using namespace std;

    AnsiString a;
    const bool SERIAL_NUMBER = true;
    string *p = new string("");
    string saveName;

    for(int y = 1; y <= 10; ++y) {
        a = label[y]->Caption;
        delete p;
        p = new string( a.c_str() );
        readLabels[ y + 6 ] = *p;
    }

    delete p;

    TimeName wt(SEE, TEXT_FILE);
    saveName = wt.temporaryName(SERIAL_NUMBER);
    statusBarMessage(saveName);

    ofstream text( saveName.c_str() );
    if( text.fail() ) {
        return false;
    }

    for(int i = 0; i < 18; ++i) {
        text << readLabels[i] << endl;
    }

    return true;
}

bool TForm1::readManageText() {
    using namespace std;

    char c[SMALL_BUFFER_SIZE];
    const string manage_text(MANAGE_TEXT);
    ifstream in(MANAGE_TEXT);
    if( in.fail() ) {
        error = "e2: ifstream in( " + manage_text + CLOSE_BRACKET;
        return false;
    }

    statusBarText = manage_text;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, SMALL_BUFFER_SIZE) ) {
            if(line == MARK_LINE) {
                if(! strcmp(c, "0") ) {
                    Close();
                }

                break;
            }

        } else {
            break;
        }

    }

    in.close();
    return true;
}

bool TForm1::where() {
    using namespace std;

    const int ADJUSTER = 41;
    const int BORDER = 2;
    const string INSIDE("inside");
    const string OUTSIDE("outside");
    POINT pos;

    ::GetCursorPos(&pos);

    bool inside = false;
    int upper_left_x = Left + BORDER;
    int upper_left_y = Top + ADJUSTER;
    int upper_right_x = upper_left_x + ClientWidth;
    int lower_left_y = upper_left_y + ClientHeight - EDIT_FIELD_HEIGHT;
    string here = OUTSIDE;
    if(upper_left_x < pos.x && pos.x < upper_right_x) {
        if(upper_left_y < pos.y && pos.y < lower_left_y) {
            here = INSIDE;
            inside = true;
        }

    }

    stringstream os;
    os << pos.x << " : " << pos.y << " ( " << here << " ) ";
    string s = os.str();
    const AnsiString X_COLON_Y( s.c_str() );
    Edit2->Text = X_COLON_Y;
    return inside;
}

int modified_file(const char *file_name) {
    AnsiString FILE_NAME(file_name);
    return FileAge(FILE_NAME);
}

NAMES driveDirectoryBase(std::string & s) {
    using namespace std;

    const string EMPTY = "";
    const string SLASH = "/";
    const string YEN = "\\";
    int firstTrace, trace, w;
    int s_length = s.length();
    string c;

    NAMES part, undivided;
    part.name[0] = EMPTY; part.name[1] = EMPTY; part.name[2] = EMPTY; part.name[3] = EMPTY;
    undivided.name[0] = EMPTY; undivided.name[1] = EMPTY; undivided.name[2] = EMPTY; undivided.name[3] = EMPTY;

    part.name[0] = s; // s.length > 0; in other words, part.name[0].length > undivided.name[0].length

// s is divided into three parts: drive name, directory name, and base name.
    int k = 0;
    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == YEN) {
            part.separator = YEN;
            break;
        } else if(c == SLASH) {
            part.separator = SLASH;
            break;
        }

    }

    if(k == s_length) { // Neither YEN nor SLASH has been found.
        return undivided;
    } else {
        w = k + 1;
        part.name[1] = s.substr(0, w); // C:\ for example
        trace = ++k;
        firstTrace = trace;
    }

    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == part.separator) {
            trace = ++k;
        }

    }

    w = trace - firstTrace;
    part.name[2] = s.substr(firstTrace, w);
    part.name[3] = s.substr(trace); // manage.txt for example
    return part;
}

std::string TForm1::kanjiColors(std::string & line) {
    using namespace std;

    BallColorSet *bcs = new BallColorSet();
    int ball_set, c;
    Dividing d(line);
    const int FIELD_COUNT = d.fieldCount();
    string field[ PLACE_COUNT + 1 ];

    for(int i = 0; i < FIELD_COUNT; ++i) {
        field[i] = d.a(i);
        if( field[i].length() == 0 ) {
            break;
        }

    }

    string FIELD_9 = field[9];
    string FIELD_10 = field[10];
    stringstream os;

    ball_set = setNameNumber[FIELD_9];

    string ascii_set = FIELD_9.substr(1);
    const AnsiString A_J( ascii_set.c_str() );
    AnsiString a = A_J + KANJI_SET;
    const string A_J_KANJI_SET( a.c_str() );
    Label3->Caption = a;
    readLabels[2] = A_J_KANJI_SET;

    string draw_number = FIELD_10.substr(1);

    for(int i = 0; i < BALLS_BONUS; ++i) {
        c = bcs->ballColor(field[i], ball_set);
        switch(c) {
        case RED:
            os << KANJI_RED << GAP;
            break;
        case YELLOW:
            os << KANJI_YELLOW << GAP;
            break;
        case BEIGE:
            os << KANJI_BEIGE << GAP;
            break;
        case GREEN:
            os << KANJI_GREEN << GAP;
            break;
        case BLUE:
            os << KANJI_BLUE << GAP;
            break;
        case NAVY:
            os << KANJI_NAVY << GAP;
            break;
        case PURPLE:
            os << KANJI_PURPLE << GAP;
            break;
        default:
            break;
        }

    }

    string kanji_colors = os.str();
    const AnsiString KANJI_COLORS( kanji_colors.c_str() );
    Label2->Caption = KANJI_COLORS;
    readLabels[1] = kanji_colors;

    delete bcs;
    return draw_number;
}

std::string TForm1::smallerBigger(std::string & pair) {
    using namespace std;

    const int GAP_SIZE = 1;
    int q;
    q = pair.find(GAP);
    string first = pair.substr(0, q);
    q += GAP_SIZE;
    string second = pair.substr(q);

    q = second.find(GAP);
    if(q != string::npos) {
        second = second.substr(0, q);
    }

    int n1, n2;
    stringstream ss(first);
    ss >> n1;
    stringstream sm(second);
    sm >> n2;

    stringstream os;
    if(n1 < n2) {
        os << first << GAP << second;
    } else {
        os << second << GAP << first;
    }

    string s = os.str();
    return s;
}

void __fastcall TForm1::handler00(TObject *Sender) {
    missingBonusHandler(mb[0][0]);
}

void __fastcall TForm1::handler01(TObject *Sender) {
    missingBonusHandler(mb[0][1]);
}

void __fastcall TForm1::handler02(TObject *Sender) {
    missingBonusHandler(mb[0][2]);
}

void __fastcall TForm1::handler03(TObject *Sender) {
    missingBonusHandler(mb[0][3]);
}

void __fastcall TForm1::handler04(TObject *Sender) {
    missingBonusHandler(mb[0][4]);
}

void __fastcall TForm1::handler05(TObject *Sender) {
    missingBonusHandler(mb[0][5]);
}

void __fastcall TForm1::handler06(TObject *Sender) {
    missingBonusHandler(mb[0][6]);
}

void __fastcall TForm1::handler10(TObject *Sender) {
    missingBonusHandler(mb[1][0]);
}

void __fastcall TForm1::handler11(TObject *Sender) {
    missingBonusHandler(mb[1][1]);
}

void __fastcall TForm1::handler12(TObject *Sender) {
    missingBonusHandler(mb[1][2]);
}

void __fastcall TForm1::handler13(TObject *Sender) {
    missingBonusHandler(mb[1][3]);
}

void __fastcall TForm1::handler14(TObject *Sender) {
    missingBonusHandler(mb[1][4]);
}

void __fastcall TForm1::handler15(TObject *Sender) {
    missingBonusHandler(mb[1][5]);
}

void __fastcall TForm1::handler16(TObject *Sender) {
    missingBonusHandler(mb[1][6]);
}

void TForm1::add(int b, int c) {
    BallColorSet *bcs = new BallColorSet();
    std::string s = bcs->ballSetList(b, c); // list of ball sets
    buffer << s;
    delete bcs;
}

void TForm1::announcement(std::string & draw_number, std::string & s) {
    using namespace std;

    int q;
    const int Q = LOTO_7 * 3;
    string head = s.substr(0, Q);
    string tail = s.substr(Q);
    string smaller_bigger = smallerBigger(tail);

    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        q = head.find(ball[i]);
        if(q != string::npos) {
            check[i] = true;
        } else {
            check[i] = false;
        }

    }

    stringstream os;
    os << KANJI_DAI << draw_number << KANJI_KAI << GAP;
    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        if(check[i]) {
            os << ball[i] << GAP;
        }

    }

    os << PARENTHESIS << smaller_bigger << ") ";
    string sorted = os.str();
    const AnsiString ANNOUNCEMENT( sorted.c_str() );
    Label5->Caption = ANNOUNCEMENT;
    readLabels[4] = sorted;
}

void TForm1::arrayBallXY() {
    using namespace std;

    AnsiString *p = new AnsiString("");
    AnsiString head[11];
    AnsiString tail[8];
    bool found;
    int width = 4;
    string s;
    stringstream *os = new stringstream();

    head[0] = "";
    head[1] = "01";
    head[2] = "02";
    head[3] = "03";
    head[4] = "04";
    head[5] = "05";
    head[6] = "06";
    head[7] = "07";
    head[8] = "08";
    head[9] = "09";
    head[10] = "10";

    tail[0] = "";
    tail[1] = "31";
    tail[2] = "32";
    tail[3] = "33";
    tail[4] = "34";
    tail[5] = "35";
    tail[6] = "36";
    tail[7] = "37";

    b[0] = new BallXY(ball[0], 0, 0, check[0]);
    b[1] = new BallXY(ball[1], 1, 1, check[1]);
    b[2] = new BallXY(ball[2], 1, 2, check[2]);
    b[3] = new BallXY(ball[3], 1, 3, check[3]);
    b[4] = new BallXY(ball[4], 1, 4, check[4]);
    b[5] = new BallXY(ball[5], 1, 5, check[5]);
    b[6] = new BallXY(ball[6], 1, 6, check[6]);
    b[7] = new BallXY(ball[7], 1, 7, check[7]);
    b[8] = new BallXY(ball[8], 1, 8, check[8]);
    b[9] = new BallXY(ball[9], 1, 9, check[9]);
    b[10] = new BallXY(ball[10], 1, 10, check[10]);
    b[11] = new BallXY(ball[11], 2, 1, check[11]);
    b[12] = new BallXY(ball[12], 2, 2, check[12]);
    b[13] = new BallXY(ball[13], 2, 3, check[13]);
    b[14] = new BallXY(ball[14], 2, 4, check[14]);
    b[15] = new BallXY(ball[15], 2, 5, check[15]);
    b[16] = new BallXY(ball[16], 2, 6, check[16]);
    b[17] = new BallXY(ball[17], 2, 7, check[17]);
    b[18] = new BallXY(ball[18], 2, 8, check[18]);
    b[19] = new BallXY(ball[19], 2, 9, check[19]);
    b[20] = new BallXY(ball[20], 2, 10, check[20]);
    b[21] = new BallXY(ball[21], 3, 1, check[21]);
    b[22] = new BallXY(ball[22], 3, 2, check[22]);
    b[23] = new BallXY(ball[23], 3, 3, check[23]);
    b[24] = new BallXY(ball[24], 3, 4, check[24]);
    b[25] = new BallXY(ball[25], 3, 5, check[25]);
    b[26] = new BallXY(ball[26], 3, 6, check[26]);
    b[27] = new BallXY(ball[27], 3, 7, check[27]);
    b[28] = new BallXY(ball[28], 3, 8, check[28]);
    b[29] = new BallXY(ball[29], 3, 9, check[29]);
    b[30] = new BallXY(ball[30], 3, 10, check[30]);
    b[31] = new BallXY(ball[31], 4, 1, check[31]);
    b[32] = new BallXY(ball[32], 4, 2, check[32]);
    b[33] = new BallXY(ball[33], 4, 3, check[33]);
    b[34] = new BallXY(ball[34], 4, 4, check[34]);
    b[35] = new BallXY(ball[35], 4, 5, check[35]);
    b[36] = new BallXY(ball[36], 4, 6, check[36]);
    b[37] = new BallXY(ball[37], 4, 7, check[37]);
    b[38] = new BallXY(ball[38], 4, 8, check[38]);
    b[39] = new BallXY(ball[39], 4, 9, check[39]);
    b[40] = new BallXY(ball[40], 4, 10, check[40]);
    b[41] = new BallXY(ball[41], 5, 1, check[41]);
    b[42] = new BallXY(ball[42], 5, 2, check[42]);
    b[43] = new BallXY(ball[43], 5, 3, check[43]);


    label[0] = NULL;
    label[1] = Label8;
    label[2] = Label9;
    label[3] = Label10;
    label[4] = Label11;
    label[5] = Label12;
    label[6] = Label13;
    label[7] = Label14;
    label[8] = Label15;
    label[9] = Label16;
    label[10] = Label17;

    for(int y = 1; y <= 10; ++y) {
        delete os;
        os = new stringstream();

        if(y > 7) { // 38, 39, 40
            width = 3;
        }

        for(int x = 1; x <= width; ++x) {
            found = false;

// Checking if a black circle appears at (x, y)
            for(int i = 1; i <= LOTO_6_COUNT; ++i) {
                if( x == b[i]->ballX() ) {
                    if( y == b[i]->ballY() ) {
                        if( b[i]->black() ) {
                            found = true;
                        }

                    }

                }

            }

            if(found) {
                *os << BLACK_CIRCLE;
            } else {
                *os << WHITE_CIRCLE;
            }

        }

        s = os->str();
        delete p;
        p = new AnsiString( s.c_str() );
        if(width == 3) {
            label[y]->Caption = head[y] + *p;
        } else {
            label[y]->Caption = head[y] + *p + tail[y];
        }

    }

    for(int i = 0; i <= LOTO_6_COUNT; ++i) {
        delete b[i];
        b[i] = NULL;
    }

    delete os;
    delete p;
}

void TForm1::beigeBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkBeige.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::blueBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkBlue.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::copyHandler() {
    char buffer[SMALL_BUFFER_SIZE];
    strcpy(buffer, statusBarText.c_str() );
    Clipboard()->SetTextBuf(buffer);
}

void TForm1::decideWhichSet() {
    if(beige_number != UNASSIGNED) {
        add(beige_number, BEIGE);
    }

    if(blue_number != UNASSIGNED) {
        add(blue_number, BLUE);
    }

    if(green_number != UNASSIGNED) {
        add(green_number, GREEN);
    }

    if(navy_number != UNASSIGNED) {
        add(navy_number, NAVY);
    }

    if(purple_number != UNASSIGNED) {
        add(purple_number, PURPLE);
    }

    if(red_number != UNASSIGNED) {
        add(red_number, RED);
    }

    if(yellow_number != UNASSIGNED) {
        add(yellow_number, YELLOW);
    }

    std::string list_of_ball_sets = buffer.str();
    if( list_of_ball_sets.length() > 0 ) {
        statusBarMessage(list_of_ball_sets);
    }

}

void TForm1::divideDraw(std::string & line, bool bonus) {
    BallColorSet *bcs = new BallColorSet();
    const int COUNT = bonus ? BALLS_BONUS : LOTO_7;
    int c;
    Dividing d(line);
    const int FIELD_COUNT = d.fieldCount();
    std::string field[ PLACE_COUNT + 1 ];

    for(int i = 0; i < FIELD_COUNT; ++i) {
        field[i] = d.a(i);
        if( field[i].length() == 0 ) {
            break;
        }

    }

    int ball_set = setNameNumber[ field[9] ];
    for(int i = 0; i < COUNT; ++i) {
        c = bcs->ballColor(field[i], ball_set);
        switch(c) {
        case RED:
            redBackground(field[i], i);
            break;
        case YELLOW:
            yellowBackground(field[i], i);
            break;
        case BEIGE:
            beigeBackground(field[i], i);
            break;
        case GREEN:
            greenBackground(field[i], i);
            break;
        case BLUE:
            blueBackground(field[i], i);
            break;
        case NAVY:
            navyBackground(field[i], i);
            break;
        case PURPLE:
            purpleBackground(field[i], i);
            break;
        default:
            break;
        }

    }

    delete bcs;
}

void TForm1::draw_as_it_is(std::string & s) {
    const bool LOTO_7_WITH_BONUS_BALLS = true;
    divideDraw(s, LOTO_7_WITH_BONUS_BALLS);
}

void TForm1::greenBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkGreen.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::missingBonusHandler(MissingBonus *p) {
    using namespace std;

// Replacing a missing ball with a bonus ball
    const int B = p->bonusBallNumber();
    const bool OLD_CHECK = check[B];
    check[B] = true;

    const int M = p->missingBallNumber();
    const bool OLD_MISSING = check[M];
    check[M] = false;
    arrayBallXY();
    createSeeText();

// Restoring
    check[B] = OLD_CHECK;
    check[M] = OLD_MISSING;
}

void TForm1::navyBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkNavy.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::newMenuItems(std::string & s) {
    using namespace std;

    const int GAP_SIZE = 1;
    const int Q = LOTO_7 * 3;
    string pair = s.substr(Q);
    int q;
    TMenuItem *to_item;

    q = pair.find(GAP);
    string first = pair.substr(0, q);
    q += GAP_SIZE;
    string second = pair.substr(q);

    q = second.find(GAP);
    if(q != string::npos) {
        second = second.substr(0, q);
    }

    to_item = MainMenu1->Items->Items[0]; //  MainMenu1->Items->Count - 1 = 0
    item[0][0] = new TMenuItem(to_item);
    item[0][0]->Caption = itemCaption(s, first, 0, 0);
    item[0][0]->OnClick = handler00;
    to_item->OnClick = NULL;
    to_item->Insert(to_item->Count, item[0][0]);

    item[0][1] = new TMenuItem(to_item);
    item[0][1]->Caption = itemCaption(s, first, 0, 1);
    item[0][1]->OnClick = handler01;
    to_item->Insert(to_item->Count, item[0][1]);

    item[0][2] = new TMenuItem(to_item);
    item[0][2]->Caption = itemCaption(s, first, 0, 2);
    item[0][2]->OnClick = handler02;
    to_item->Insert(to_item->Count, item[0][2]);

    item[0][3] = new TMenuItem(to_item);
    item[0][3]->Caption = itemCaption(s, first, 0, 3);
    item[0][3]->OnClick = handler03;
    to_item->Insert(to_item->Count, item[0][3]);

    item[0][4] = new TMenuItem(to_item);
    item[0][4]->Caption = itemCaption(s, first, 0, 4);
    item[0][4]->OnClick = handler04;
    to_item->Insert(to_item->Count, item[0][4]);

    item[0][5] = new TMenuItem(to_item);
    item[0][5]->Caption = itemCaption(s, first, 0, 5);
    item[0][5]->OnClick = handler05;
    to_item->Insert(to_item->Count, item[0][5]);

    item[0][6] = new TMenuItem(to_item);
    item[0][6]->Caption = itemCaption(s, first, 0, 6);
    item[0][6]->OnClick = handler06;
    to_item->Insert(to_item->Count, item[0][6]);

    item[1][0] = new TMenuItem(to_item);
    item[1][0]->Caption = itemCaption(s, second, 1, 0);
    item[1][0]->OnClick = handler10;
    to_item->Insert(to_item->Count, item[1][0]);

    item[1][1] = new TMenuItem(to_item);
    item[1][1]->Caption = itemCaption(s, second, 1, 1);
    item[1][1]->OnClick = handler11;
    to_item->Insert(to_item->Count, item[1][1]);

    item[1][2] = new TMenuItem(to_item);
    item[1][2]->Caption = itemCaption(s, second, 1, 2);
    item[1][2]->OnClick = handler12;
    to_item->Insert(to_item->Count, item[1][2]);

    item[1][3] = new TMenuItem(to_item);
    item[1][3]->Caption = itemCaption(s, second, 1, 3);
    item[1][3]->OnClick = handler13;
    to_item->Insert(to_item->Count, item[1][3]);

    item[1][4] = new TMenuItem(to_item);
    item[1][4]->Caption = itemCaption(s, second, 1, 4);
    item[1][4]->OnClick = handler14;
    to_item->Insert(to_item->Count, item[1][4]);

    item[1][5] = new TMenuItem(to_item);
    item[1][5]->Caption = itemCaption(s, second, 1, 5);
    item[1][5]->OnClick = handler15;
    to_item->Insert(to_item->Count, item[1][5]);

    item[1][6] = new TMenuItem(to_item);
    item[1][6]->Caption = itemCaption(s, second, 1, 6);
    item[1][6]->OnClick = handler16;
    to_item->Insert(to_item->Count, item[1][6]);
}

void TForm1::purpleBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkPurple.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::redBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkRed.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}

void TForm1::sorting(std::string & s) {
    using namespace std;

    int q;
    const int Q = LOTO_7 * 3;
    const bool LOTO_7_WITHOUT_BONUS_BALLS = false;
    string head = s.substr(0, Q);
    string tail = s.substr(Q);

    check[0] = false;
    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        q = head.find(ball[i]);
        if(q != string::npos) {
            check[i] = true;
        } else {
            check[i] = false;
        }

    }

    stringstream os;
    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        if(check[i]) {
            os << ball[i] << GAP;
        }

    }

    os << tail;
    string sorted = os.str();
    divideDraw(sorted, LOTO_7_WITHOUT_BONUS_BALLS);
}

void TForm1::statusBarMessage(std::string & s) {
    statusBarText = s;
    const AnsiString MESSAGES( s.c_str() );
    Edit1->Text = MESSAGES;
}

void TForm1::yellowBackground(std::string & figure, int k) {
    int ball_number = ballNameNumber[figure];
    int place_number = k + 1;
    TImage *p = place[place_number];
    p->Picture->LoadFromFile( zokoMarkYellow.c_str() );

    ImageList1->DrawingStyle = dsTransparent;
    ImageList1->Draw(p->Canvas, IMAGE_LEFT, IMAGE_TOP, ball_number, ENABLED);
    p->Left = cellLeft[place_number];
    p->Visible = true;
}


__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner), B01("01"), B02("02"), B03("03"), B04("04"), B05("05"), B06("06"), B07("07"), B08("08"), B09("09"), B10("10"), B11("11"), B12("12"), B13("13"), B14("14"), B15("15"), B16("16"), B17("17"), B18("18"), B19("19"), B20("20"), B21("21"), B22("22"), B23("23"), B24("24"), B25("25"), B26("26"), B27("27"), B28("28"), B29("29"), B30("30"), B31("31"), B32("32"), B33("33"), B34("34"), B35("35"), B36("36"), B37("37"), B38("38"), B39("39"), B40("40"), B41("41"), B42("42"), B43("43"), 
BLACK_CIRCLE(""), CLOSE_BRACKET(") "), EMPTY(""), ENABLED(true), GAP(" "), HYPHEN("-"), KANJI_BEIGE("x"), KANJI_BLUE(""), KANJI_DAI(""), KANJI_GREEN(""), KANJI_KAI(""), KANJI_NAVY(""), KANJI_PURPLE(""), KANJI_RED(""), KANJI_SET("Zbg"), KANJI_YELLOW(""), L01112131("@ 01112131"), L102030("@ 102030"), M01("-A"), M02("-B"), M03("-C"), M04("-D"), M05("-E"), M06("-F"), M07("-G"), M08("-H"), M09("-I"), M10("-J"), 
MARK_INFO_BEIGE("markBeige.bmp"), MARK_INFO_BLUE("markBlue.bmp"), MARK_INFO_GREEN("markGreen.bmp"), MARK_INFO_NAVY("markNavy.bmp"), MARK_INFO_PURPLE("markPurple.bmp"), MARK_INFO_RED("markRed.bmp"), MARK_INFO_YELLOW("markYellow.bmp"), MINUS("-"), PARENTHESIS("("), SERIAL_NUMBER(true), WHITE_CIRCLE("")
{
    Width = MAIN_WIDTH;
    Edit1->Left = 0;
    Edit1->Height = EDIT_FIELD_HEIGHT;
    Edit1->Width = EDIT_FIELD_WIDTH;
    Edit2->Left = EDIT_FIELD_WIDTH;
    Edit2->Height = EDIT_FIELD_HEIGHT;
    Edit2->Width = SMALL_EDIT_FIELD_WIDTH;
    Label1->Width = CLIENT_WIDTH; Label2->Width = CLIENT_WIDTH; Label3->Width = CLIENT_WIDTH; Label4->Width = CLIENT_WIDTH; Label5->Width = CLIENT_WIDTH; Label6->Width = CLIENT_WIDTH; Label7->Width = CLIENT_WIDTH; Label8->Width = CLIENT_WIDTH; Label9->Width = CLIENT_WIDTH; Label10->Width = CLIENT_WIDTH; Label11->Width = CLIENT_WIDTH; Label12->Width = CLIENT_WIDTH; Label13->Width = CLIENT_WIDTH; Label14->Width = CLIENT_WIDTH; Label15->Width = CLIENT_WIDTH; Label16->Width = CLIENT_WIDTH; Label17->Width = CLIENT_WIDTH; Label18->Width = CLIENT_WIDTH; 
    Label1->Height = LABEL_HEIGHT; Label2->Height = LABEL_HEIGHT; Label3->Height = LABEL_HEIGHT; Label4->Height = LABEL_HEIGHT; Label5->Height = LABEL_HEIGHT; Label6->Height = LABEL_HEIGHT; Label7->Height = LABEL_HEIGHT; Label8->Height = LABEL_HEIGHT; Label9->Height = LABEL_HEIGHT; Label10->Height = LABEL_HEIGHT; Label11->Height = LABEL_HEIGHT; Label12->Height = LABEL_HEIGHT; Label13->Height = LABEL_HEIGHT; Label14->Height = LABEL_HEIGHT; Label15->Height = LABEL_HEIGHT; Label16->Height = LABEL_HEIGHT; Label17->Height = LABEL_HEIGHT; Label18->Height = LABEL_HEIGHT; 
    Label1->Top = 50;  Label1->AutoSize = false;
    Label2->Top = 66;  Label2->AutoSize = false;
    Label3->Top = 82;  Label3->AutoSize = false;
    Label4->Top = 98;  Label4->AutoSize = false;
    Label5->Top = 114; Label5->AutoSize = false;
    Label6->Top = 130; Label6->AutoSize = false;
    Label7->Top = 146; Label7->AutoSize = false;
    Label8->Top = 162; Label8->AutoSize = false;
    Label9->Top = 178; Label9->AutoSize = false;
    Label10->Top = 194; Label10->AutoSize = false;
    Label11->Top = 210; Label11->AutoSize = false;
    Label12->Top = 226; Label12->AutoSize = false;
    Label13->Top = 242; Label13->AutoSize = false;
    Label14->Top = 258; Label14->AutoSize = false;
    Label15->Top = 274; Label15->AutoSize = false;
    Label16->Top = 290; Label16->AutoSize = false;
    Label17->Top = 306; Label17->AutoSize = false;
    Label18->Top = 322; Label18->AutoSize = false;

    for(int i = 0; i <= LOTO_6_COUNT; ++i) {
        b[i] = NULL;
    }

    for(int i = 0; i < LOTO_7; i += 1 ) {
        mb[0][i] = NULL;
        mb[1][i] = NULL;
    }

    place[0] = NULL; 
    place[1] = Image1; place[2] = Image2; place[3] = Image3; place[4] = Image4; place[5] = Image5; place[6] = Image6; place[7] = Image7; place[8] = Image8; place[9] = Image9; place[10] = Image10; place[11] = Image11;

    const int CELL_10 = CELL_WIDTH * ( PLACE_COUNT - 1 );
    TImage *p;
    for(int i = 1; i <= PLACE_COUNT; ++i) {
        cellLeft[i] = CELL_WIDTH * ( i - 1 );

        p = place[i];
        p->Left = CELL_10;
        p->Top = 0;
        p->Visible = false;
    }

// Mapping ball numbers to ball names
    ball[0] = EMPTY;
    ball[1] = B01; ball[2] = B02; ball[3] = B03; ball[4] = B04; ball[5] = B05; ball[6] = B06; ball[7] = B07; ball[8] = B08; ball[9] = B09; ball[10] = B10;
    ball[11] = B11; ball[12] = B12; ball[13] = B13; ball[14] = B14; ball[15] = B15; ball[16] = B16; ball[17] = B17; ball[18] = B18; ball[19] = B19; ball[20] = B20;
    ball[21] = B21; ball[22] = B22; ball[23] = B23; ball[24] = B24; ball[25] = B25; ball[26] = B26; ball[27] = B27; ball[28] = B28; ball[29] = B29; ball[30] = B30;
    ball[31] = B31; ball[32] = B32; ball[33] = B33; ball[34] = B34; ball[35] = B35; ball[36] = B36; ball[37] = B37; ball[38] = B38; ball[39] = B39; ball[40] = B40;
    ball[41] = B41; ball[42] = B42; ball[43] = B43;

// Mapping ball names to ball numbers
    for(int i = 0; i <= LOTO_6_COUNT; ++i) {
        ballNameNumber[ ball[i] ] = i;
    }

// Mapping set numbers to set names
    BALL_SET[0] = M01; BALL_SET[1] = M02; BALL_SET[2] = M03; BALL_SET[3] = M04; BALL_SET[4] = M05; BALL_SET[5] = M06; BALL_SET[6] = M07; BALL_SET[7] = M08; BALL_SET[8] = M09; BALL_SET[9] = M10;

// Mapping set names to set numbers
    for(int i = 0; i < BALL_SET_COUNT; ++i) {
        setNameNumber[ BALL_SET[i] ] = i;
    }

    beige_number = mm->ballNumber(BEIGE);
    blue_number = mm->ballNumber(BLUE);
    line_1 = mm->firstLine();
    green_number = mm->ballNumber(GREEN);
    navy_number = mm->ballNumber(NAVY);
    purple_number = mm->ballNumber(PURPLE);
    red_number = mm->ballNumber(RED);
    show_where = mm->showWhere();
    sort_balls = mm->sortBalls();
    yellow_number = mm->ballNumber(YELLOW);

    zokoMarkYellow = mm->fullPathName();
    NAMES a = driveDirectoryBase(zokoMarkYellow);
    std::string SEPARATOR = a.separator;
    std::string root = a.name[1]; // C:\ for example
    std::string directory = a.name[2]; // zokoVCL\Mark\info\ for example
    zokoMarkBeige = root + directory + MARK_INFO_BEIGE;
    zokoMarkBlue = root + directory + MARK_INFO_BLUE;
    zokoMarkGreen = root + directory + MARK_INFO_GREEN;
    zokoMarkNavy = root + directory + MARK_INFO_NAVY;
    zokoMarkPurple = root + directory + MARK_INFO_PURPLE;
    zokoMarkRed = root + directory + MARK_INFO_RED;
    zokoMarkYellow = root + directory + MARK_INFO_YELLOW;

    const int Q = BALLS_BONUS * 3;
    std::string ballsBonus = line_1.substr(0, Q);
    readLabels[0] = ballsBonus;
    readLabels[3] = EMPTY;
    readLabels[5] = EMPTY;
    readLabels[6] = L01112131;
    readLabels[17] = L102030;

    const AnsiString AS( ballsBonus.c_str() );
    Label1->Caption = AS;
    Label4->Caption = "";
    Label6->Caption = "";
    Label7->Caption = "@ 01112131"; // Shift_JIS
    Label18->Caption = "@ 102030";

    drawNumber = kanjiColors(line_1); // Label2, Label3
    announcement(drawNumber, line_1); // check[], Label5
    newMenuItems(line_1);
    arrayBallXY(); // label[]
    createSeeText();
    decideWhichSet();
    if(sort_balls) {
         sorting(line_1);
    } else {
         draw_as_it_is(line_1);
    }

    const AnsiString F3_TO_CLOSE("Press F3 to close");
    Edit2->Text = F3_TO_CLOSE;

    unhandled = modified_file(MANAGE_TEXT);
    firstSession = true;
    Timer1->Interval = NON_SAMPLING_PERIOD;
}

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Draw1Click(TObject *Sender)
{
    arrayBallXY();
    createSeeText();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Copy1Click(TObject *Sender)
{
    copyHandler();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    if(show_where) {
// Showing where the cursor is
        where();
    }

// Checking if MANAGE_TEXT has been modified
    int m = modified_file(MANAGE_TEXT);
    if(m != unhandled) {
        unhandled = m;
        perused = readManageText();
    }

    if(firstSession) {
        Button1->SetFocus();
        firstSession = false;
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Help1Click(TObject *Sender)
{
    int error = executeProgram(ZOKO_PDF, "");
    if(error <= 32) {
        Application->HelpContext(IDH_MARK);
    }

}
//---------------------------------------------------------------------------

