#include "EditCount.h"

extern MANAGE_MEMO *mm;

bool EditCount::editCount() {
    bool result;
    Combo *co = NULL;
    Drafo *dr = NULL;
    ExcludeText *et = NULL;
    FormDateLine *fd = NULL;
    NewLines *nl = NULL;
    TableCsv *tc = NULL;
    ZokoBonus *zb = NULL;
    ZokoMask *zm = NULL;

    if(preedit) {
        if(threeLinesUnited) {
            fd = new FormDateLine(firstLine, serialNumber, whoText);
            if( fd->altering(fileName) ) {
                fileName = fd->altered();
            } else {
                error = fd->inquiry();
                delete fd; 
                return false;
            }

            delete fd; 
        }

        et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
        if( et->altering(fileName) ) {
            fileName = et->altered();
        } else {
            error = et->inquiry();
            delete et;
            return false;
        }

        std::string drafoCsv = DRAFO_CSV;
        dr = new Drafo(drafoCsv, firstLine, serialNumber, whoText);
        if( dr->altering(fileName) ) {
            fileName = dr->altered();
        } else {
            error = dr->inquiry();
            delete dr; delete et;
            return false;
        }

        co = new Combo(firstLine, serialNumber, whoText);
        if( co->altering(fileName) ) {
            fileName = co->altered();
        } else {
            error = co->inquiry();
            delete co; delete dr; delete et; 
            return false;
        }

        nl = new NewLines(firstLine, serialNumber, whoText);
        if( nl->altering(fileName) ) {
            fileName = nl->altered();
        } else {
            error = nl->inquiry();
            delete co; delete dr; delete et; delete nl; 
            return false;
        }

        delete co; delete dr; delete et; delete nl;
    }

    if(quit) {
        textName = fileName;
        return true;
    }

    if(csv) {
        tc = new TableCsv(rowCount, serialNumber, whoText);
        if( tc->run(fileName) ) {
            textName = tc->saved();
            result = true;
        } else {
            error = tc->inquiry();
            result = false;
        }

        delete tc;
    } else {
        if(countBonus) {
            zb = new ZokoBonus(balls, noSplitting, serialNumber, whoText);
            if( zb->run(fileName) ) {
                textName = zb->saved();
                result = true;
            } else {
                error = zb->inquiry();
                result = false;
            }

            delete zb;
        } else {
            zm = new ZokoMask(balls, noSplitting, serialNumber, whoText);
            if( zm->run(fileName) ) {
                textName = zm->saved();
                result = true;
            } else {
                error = zm->inquiry();
                result = false;
            }

            delete zm;
        }

    }

    return result;
}

bool EditCount::preediting() {
    using namespace std;

    bool result;
    Combo *co = NULL;
    Drafo *dr = NULL;
    ExcludeText *et = NULL;
    FormDateLine *fd = NULL;
    NewLines *nl = NULL;
    stringstream os;

    if(threeLinesUnited) {
        fd = new FormDateLine(firstLine, serialNumber, whoText);
        if( fd->altering(fileName) ) {
            fileName = fd->altered();
            os << "-3: " << fileName << NEW_LINE;
        } else {
            error = fd->inquiry();
            delete fd; 
            return false;
        }

        delete fd;
    }

    et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
    if( et->altering(fileName) ) {
        fileName = et->altered();
        os << "-e: " << fileName << NEW_LINE;
    } else {
        error = et->inquiry();
        delete et;
        return false;
    }

    string drafoCsv = DRAFO_CSV;
    dr = new Drafo(drafoCsv, firstLine, serialNumber, whoText);
    if( dr->altering(fileName) ) {
        fileName = dr->altered();
        os << "-z: " << fileName << NEW_LINE;
    } else {
        error = dr->inquiry();
        delete dr; delete et; 
        return false;
    }

    co = new Combo(firstLine, serialNumber, whoText);
    if( co->altering(fileName) ) {
        fileName = co->altered();
        os << "-c: " << fileName << NEW_LINE;
    } else {
        error = co->inquiry();
        delete co; delete dr; delete et; 
        return false;
    }

    nl = new NewLines(firstLine, serialNumber, whoText);
    if( nl->altering(fileName) ) {
        fileName = nl->altered();
        os << "-n: " << fileName << NEW_LINE;
    } else {
        error = nl->inquiry();
        delete co; delete dr; delete et; delete nl; 
        return false;
    }

    delete co; delete dr; delete et; delete nl;
    textName = fileName;

    string s = os.str();
    ofstream file(DIR_SLASH_O_COLON_D);
    file << s;
    return true;
}

bool EditCount::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e19: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    stringArrayToValues();
    delete p;
    return true;
}

bool EditCount::setting(std::string f, std::string fi, std::string l, int b, bool c, bool cs, bool fir, bool n, bool p, bool q, bool s, bool t, bool w) {
    using namespace std;

    FULL_PATH_NAME = f;
    readManageText();

    fileName = fi;
    list_of_items = l;
    balls = b;
    countBonus = c;
    csv = cs; // csv = true (csv may be set when Optional is new.)
    firstLine = fir;
    noSplitting = n;
    preedit = p;
    quit = q;
    serialNumber = s;
    threeLinesUnited = t;
    whoText = w;

    if(balls < 1 || 7 < balls) {
        balls = BALLS;
    }

    return true;
}

EditCount::EditCount(): DRAFO_CSV("drafo.csv"), EXCLUDE_TEXT("exclude.txt"), BALLS(4), m0(""), m1("who.txt"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), m10("0"), m11("0"), m12("1"), m13("0"), m14("20"), m15("20"), m16("800"), m17("600"), m18("1"), NEW_LINE("\n"), SEPARATE_TEXT("separate.txt"), ZERO("0") {
    csv = false;
    quit = false;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; m[13] = m13; m[14] = m14; m[15] = m15; m[16] = m16; m[17] = m17; m[18] = m18;
}

void EditCount::stringArrayToValues() {
    using namespace std;

    fileName = m[1];
    list_of_items = m[2];
    balls = integerFromString(m[3]);

    editor = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = integerFromString(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    mark = (ZERO == m[10]) ? false : true;
    whoText = (ZERO == m[11]) ? false : true;
    threeLinesUnited = (ZERO == m[12]) ? false : true;
    whichCorner = integerFromString(m[13]);

    csv_x = integerFromString(m[14]);
    csv_y = integerFromString(m[15]);
    csv_w = integerFromString(m[16]);
    csv_h = integerFromString(m[17]);
    checkBox = (ZERO == m[18]) ? false : true;

    mm->checkBox = checkBox;
    mm->csv = false;
    mm->csv_h = csv_h;
    mm->csv_w = csv_w;
    mm->csv_x = csv_x;
    mm->csv_y = csv_y;
    mm->editor = editor;
    mm->fileName = fileName;
    mm->firstLine = firstLine;
    mm->FULL_PATH_NAME = FULL_PATH_NAME;
    mm->balls = balls;
    mm->list_of_items = list_of_items;
    mm->mark = mark;
    mm->threeLinesUnited = threeLinesUnited;
    mm->noSplitting = noSplitting;
    mm->pleaseCheck = true;
    mm->preedit = preedit;
    mm->rowCount = rowCount;
    mm->serialNumber = serialNumber;
    mm->textName = textName;
    mm->whichCorner = whichCorner;
    mm->whoText = whoText;
}
