#ifndef FEEDABLE_H
#define FEEDABLE_H

#define ERROR_TEXT "error.txt"
#define LARGE_SIZE 2147483647
#include <fstream>
#include <iostream>
#include <string>
#include <time.h>

class Feedable {
protected:
    int FIELD_SIZE, FIELD_COUNT, itemCount, ITEM_SIZE, lineCount, SEPARATOR_SIZE;
    long NEW_LINE_SIZE, size;
    std::ofstream file;
    std::string error, pathName, separator;

public:
    virtual ~Feedable(){}

    std::string inquiry() const {
        return error;
    }

    void setting(std::string & s) {
        FIELD_COUNT = 20;
        ITEM_SIZE = 2; // two-digit number
        itemCount = 0;
        lineCount = 0;
        NEW_LINE_SIZE = 2L; // MS-DOS, Windows
        separator = s;
        SEPARATOR_SIZE = separator.length();
        size = 0L;
        FIELD_SIZE = ITEM_SIZE + SEPARATOR_SIZE;
    }

    bool openRannuText();
    Feedable(){}
    virtual bool ending(bool csv) = 0;
    virtual long writing(std::string & item) = 0;
};

class FileOutputNewLine: public Feedable {
public:
    ~FileOutputNewLine(){}
    FileOutputNewLine(std::string & p);
    bool ending(bool csv);
    long writing(std::string & item);
};

class FileOutputNewLineCount: public Feedable {
    int limit;

public:
    ~FileOutputNewLineCount(){}
    FileOutputNewLineCount(std::string & p, int l);
    bool ending(bool csv);
    long writing(std::string & item);
};

class StandardOutputNewLine: public Feedable {
public:
    ~StandardOutputNewLine(){}
    StandardOutputNewLine(){}
    bool ending(bool csv);
    long writing(std::string & item);
};

class StandardOutputNewLineCount: public Feedable {
    int limit;

public:
    ~StandardOutputNewLineCount(){}
    StandardOutputNewLineCount(int l) {
        limit = l;
    }

    bool ending(bool csv);
    long writing(std::string & item);
};

void createErrorText(std::string & messages);

#endif // FEEDABLE_H
