#ifndef FORM_DATE_LINE_H
#define FORM_DATE_LINE_H

#define RING_COUNT 3
#include <deque>
#include "Characte.h"
#include "TimeName.h"

typedef std::deque<std::string> RING;

class FormDateLine {
    bool firstLine, serialNumber, whoText;
    const int NEW_LINE_LENGTH;
    const std::string CLOSE_BRACKET, EMPTY, GAP, ID_COLON, NEW_LINE;
    RING ring;
    std::string error, saveName, whose;
    std::stringstream *buffer;
    std::stringstream *combos;

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    void listing() {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c;
    }

    bool openSaveClose(std::string & fileName);
    int produceRingBuffer(int size);
    void blankRingBuffer();

public:
    ~FormDateLine() {
        delete buffer;
        delete combos;
    }

    std::string altered() const {
        return saveName;
    }

    std::string inquiry() const {
        return error;
    }

    FormDateLine(bool f, bool s, bool w): CLOSE_BRACKET(" )"), EMPTY(""), GAP(" "), ID_COLON(" ID:"), NEW_LINE("\n"), NEW_LINE_LENGTH(1) {
        firstLine = f;
        serialNumber = s;
        whoText = w;

        buffer = new std::stringstream();
        combos = new std::stringstream();
        whose = EMPTY;
    }

    bool altering(std::string & fileName);
};

#endif // FORM_DATE_LINE_H
