#include "ZokoBonus.h"

extern MANAGE_MEMO *mm;

bool ZokoBonus::countBalls(std::string & s) {
    using namespace std;

    int count = 0;
    int q;

    q = s.find(draw[1]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[2]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[3]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[4]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[5]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[6]);
    if(q != string::npos) {
        count += 1;
    }

    q = s.find(draw[7]);
    if(q != string::npos) {
        count += 1;
    }

    if(count != balls) {
        return false;
    }

// Counting the bonus ball
    q = s.find(draw[8]);
    if(q != string::npos) {
        return true;
    }

    q = s.find(draw[9]);
    if(q != string::npos) {
        return true;
    }

    return false;
}

bool ZokoBonus::openSaveClose(std::string & fileName) {
    using namespace std;

// Trimming
    string s = buffer->str();
    int size = s.length();
    string c;
    for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
        c = s.substr(i, NEW_LINE_LENGTH);
        if(NEW_LINE == c) {
            continue;
        } else {
            s = s.substr(i);
            break;
        }

    }

// Writing
    ofstream saveFile( fileName.c_str() );
    if( saveFile.fail() ) {
        error = "e13: ofstream saveFile( " + fileName + CLOSE_BRACKET;
        return false;
    }

    saveFile << s;
    saveFile.close();
    return true;
}

bool ZokoBonus::run(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e14: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[TO_BUFFER_SIZE];
    char to[TO_BUFFER_SIZE];
    if( in.getline(c, TO_BUFFER_SIZE) ) {
// Line-1
        if( strlen(c) > STANDARD_LINE_LENGTH ) {
            dividing(c, to, TO_BUFFER_SIZE);
            for(int i = 0; i < DRAW_ARRAY_SIZE; ++i) {
                draw[i] = a[i];
            }

            drawLine = standardLine1();
        } else {
            const string LINE_LENGTH_ERROR("e5(Line-1): strlen(c) <= STANDARD_LINE_LENGTH");
            error = LINE_LENGTH_ERROR;
            return false;
        }

    } else {
        const string READ_ERROR("e6(Line-1): in.getline(c, TO_BUFFER_SIZE) ");
        error = READ_ERROR;
        return false;
    }

    int b, howMany, r;
    string *p = new string("");
    string extra, s;
    stringstream *os = new stringstream();
    Characterizable *lineType = new DateFollowed(*p);

    if(whoText) {
        textName = WHO_TEXT;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        textName = wt.temporaryName(serialNumber);
    }

    while( in.getline(c, BUFFER_SIZE) ) {
        scope = allQP(c);

        if( strlen(c) >= STANDARD_LINE_LENGTH ) {
            delete p;
            p = new string(c);
            s = *p;

            delete lineType;
            lineType = new DateFollowed(s);
            r = lineType->dateLine();
            if(r > 0) {
                listing();

                id = lineType->name_id();
                res_no = lineType->anchor_res_no();
                clear(id, res_no, s, r);
                continue;
            }

            dividing(c, to, TO_BUFFER_SIZE);
        } else {
            continue;
        }

        if( countBalls(s) ) {
            s = assembling();
            add(s);
        }

    }

    in.close();
    listing();
    openSaveClose(textName);

    delete lineType;
    delete os;
    delete p;
    return true;
}

ZokoBonus::ZokoBonus(int b, bool n, bool s, bool w): ALL_QP("ALL QP"), ALL_QP_SIZE(6), ANCHOR(">>"), BALLS(4), CLOSE_BRACKET(" )"), EMPTY(""), GAP(" "), ID_COLON(" ID:"), NEW_LINE("\n"), NEW_LINE_LENGTH(1), QP("QP"), SLASH("/"), SPACE("@") { // Shift_JIS
    balls = b;
    noSplitting = n;
    oneMore = false;
    serialNumber = s;
    whoText = w;

    buffer = new std::stringstream();
    combos = NULL;
    std::string empty(EMPTY);
    clear(empty, empty, empty, 0); // combos = new std::stringstream();
}

std::string ZokoBonus::assembling() {
    using namespace std;

    stringstream os;
    for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
        if( a[i].length() > 0 ) {
            os << a[i] << GAP;
        }

    }

    string s = os.str();
    return s;
}

std::string ZokoBonus::standardLine1() {
    using namespace std;

    stringstream os;
    os << draw[1] << GAP << draw[2] << GAP << draw[3] << GAP << draw[4] << GAP << draw[5] << GAP << draw[6] << GAP << draw[7] << GAP;
    string s = os.str();

    return s;
}

void ZokoBonus::dividing(char *p, char *to, int to_array_size) {
    using namespace std;

    char *from;
    int n, u;
    string *to_string = new string("");

    a[0] = EMPTY;
    memset(to, 0, to_array_size);
    for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
        n = strspn(p, "0123456789");
        from = p;
        p += n;

        u = strcspn(p, "0123456789");
        p += u;

        memcpy(to, from, n);
        to[n] = '\0';
        delete to_string;
        to_string = new string(to);
        a[i] = *to_string;
    }

    delete to_string;
}

void ZokoBonus::dividing(std::string & s, char *to, int to_array_size) {
    using namespace std;

    char *from;
    char *p;
    char c[TO_BUFFER_SIZE];
    int n, u;
    string *to_string = new string("");

    strcpy(c, s.c_str() );
    p = &c[0];
    a[0] = EMPTY;
    memset(to, 0, to_array_size);
    for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
        n = strspn(p, "0123456789");
        from = p;
        p += n;

        u = strcspn(p, "0123456789");
        p += u;

        memcpy(to, from, n);
        to[n] = '\0';
        delete to_string;
        to_string = new string(to);
        a[i] = *to_string;
    }

    delete to_string;
}

void ZokoBonus::listing() {
    using namespace std;

    bool pile = false;
    int q;
    string chopped, head, tail;
    string combosList = combos->str();

    if(split == 0) {
        *buffer << NEW_LINE << ANCHOR << whose << NEW_LINE << combosList;
        return;
    }

    switch(count) {
    case 0:
        return;
    case 1:
        break;
    default:
        pile = true;
        break;
    }

    if(pile || noSplitting) {
        if(oneMore) {
            *buffer << NEW_LINE;
            oneMore = false;
        }

        if(scope) {
            q = combosList.find(ALL_QP);
            if(q != string::npos) {
                *buffer << NEW_LINE << ANCHOR << whose << NEW_LINE << combosList;
            } else {
                q = combosList.length() - NEW_LINE_LENGTH;
                chopped = combosList.substr(0, q);
                *buffer << NEW_LINE << ANCHOR << whose << NEW_LINE << chopped << SPACE << ALL_QP << NEW_LINE;
            }

        } else {
            *buffer << NEW_LINE << ANCHOR << whose << NEW_LINE << combosList;
        }

    } else {
// Splitting the date line
        q = combosList.length() - NEW_LINE_LENGTH;
        chopped = combosList.substr(0, q);
        oneMore = true;

        if(scope) {
            q = chopped.find(ALL_QP);
            if(q != string::npos) {
                head = chopped.substr(0, q);
                q += ALL_QP_SIZE;
                tail = chopped.substr(q);
                chopped = head + tail;
            }

            *buffer << res_no << chopped << GAP << QP << id;
        } else {
            *buffer << res_no << chopped << id;
        }

    }

}

