#ifndef KUN_H
#define KUN_H

#pragma warn -8004
#pragma warn -8012

#define ALL 37
#define B00000001 1
#define B00000010 2
#define B00000100 4
#define B00001000 8
#define B00010000 16
#define B00100000 32
#define B01000000 64
#define B10000000 128
#define BITS 8
#define BOUNDARY_TEXT "boundary.txt"
#define CARET "^"
#define CARET_C '^'
#define CELL_HEIGHT 9
#define CELL_WIDTH 9
#define COMMA_SIZE 1
#define DEL 0x7F
#define ERROR_TEXT "error.txt"
#define FALSE_ITEM_SIZE 9
#define FALSE_TEXT "false.txt"
#define FULL_RECORD_SIZE 1705 // KOPIC_KUN_SIZE + PARAMETER_COUNT
#define ITEM_COUNT 30
#define ITEM_WIDTH 8
#define KANA_KUTEN 0xA1
#define KOPIC_CSV "kopic.csv"
#define KOPIC_FROM 400 // 0 < KOPIC_FROM
#define KOPIC_FROM_SEQUENCE "400"
#define KOPIC_KUN "kopic.kun"
#define KOPIC_KUN_SIZE 1688 // ( XBM_WIDTH + 2 ) * XBM_HEIGHT + SIGNATURE
#define KOPIC_REPEAT 420 // KOPIC_FROM < KOPIC_REPEAT
#define KOPIC_REPEAT_SEQUENCE "420"
#define KOPIC_TEXT "kopic.txt"
#define KOPIC_XBM "kopic.xbm"
#define KUN_FILE_ERROR -1
#define LARGE_BUFFER_SIZE 9728
#define PARAMETER_COUNT 17
#define QUOTE_C 0x22 // "
#define RECORD_SIZE 384
#define SIGNATURE 8
#define TRU "tru"
#define TRUE_TEXT "true.txt"
#define TRUE_ITEM_SIZE 9
#define VERSION_TEXT "version.txt"
#define XBM_ERROR 4040
#define XBM_HEIGHT 40
#define XBM_WIDTH 40
#include "Numbered.h"
#include "Split.h"
#include "TimeName.h"

enum BLACK_WHITE {WHITE, BLACK};
enum CORNER_PATTERN {SMALL_CIRCLE, DIAMOND, KANJI, SHOEBOX, CORNER_PATTERN_COUNT};
enum KOPIC_EXTENSION {CSV, KUN, TEXT, XBM};
enum XBM_STATUS {CSV_SPECIFIED, KUN_EXPAND, KUN_SHRINK, NOT_TREATED_AS_TRUE, RECOVERY, SHARP_TEXT, TREATED_AS_FALSE, GUIDED, COMMENTED, XBM_FILE_ERROR, XBM_READ, XBM_TO_CSV};

typedef struct KUN_CODE KUN_CODE;
struct KUN_CODE {
    bool csv, defectiveCsv, from_not_38, full_swing, grouping, kun_shrink, mapping, newXbm, sharp_symbols, weight;
    char file_name[FILE_NAME_SIZE];
    int code, cell_height, cell_width, data_height, data_width, decrement_by_n, diamond, outputLines, prng;
};

class Kun {
    bool check;
    char black, white;
    char buffer[LARGE_BUFFER_SIZE];
    char run_length[KOPIC_KUN_SIZE];
    const std::string COMMA, EMPTY, NEW_LINE, SHARP, SPACE, ZERO_X;
    int decrement_by_n, encoding_size;

    void counting(int data_width, int m);
    void mirrorImages(int data_width, int data_height);

public:
    Kun(int d): COMMA(","), EMPTY(""), NEW_LINE("\n"), SHARP("#"), SPACE(" "), ZERO_X("0x") {
        decrement_by_n = d;
    }

    int createKopicCsv(std::string essential, int data_width, int data_height, bool from_not_38);
    int shrink(char *unexpanded, int data_width, int data_height);
    int shrink(int data_width, int data_height);
    bool sharp_text(char *file_name, int data_width, int data_height);
    bool rewrite_xbm(char *file_name, int data_width, int data_height);
    void manageText(int d);
    void xbmBooleanArray(int data_width, int data_height);
};

bool createRemoveErrorText();
bool itemsTreatedAsFalse(char * file_name);
bool itemsTreatedAsTrue(char *file_name);
bool kunExpand(char *file_name);
bool removeTemporaryFiles();
int checkExtension(char *file_name);
int messagePane(char *);
int modified_file(const char *file_name);
KUN_CODE readFilesBeforeCreatingWindows(Split & a);
KUN_CODE readXbm(KUN_CODE & kc);
std::string inheritTerms();
std::string standardTerms();
void checkWidth(KUN_CODE *p);
void createKopicXbm();
void expressedAsHexadecimal();
void guide(bool comments);

#endif // KUN_H
