#ifndef RANNU_TEXT_H
#define RANNU_TEXT_H

#pragma warn -8057

#define B00000001 1
#define B00000010 2
#define B00000100 4
#define B00001000 8
#define B00010000 16
#define B00100000 32
#define BOOL_STREAM_SIZE 192 // 32 * GROUP_SIZE
#define DRAW_ARRAY_SIZE 12
#define FILE_NAME_SIZE 256
#define GROUP_SIZE 6
#define HELP_FILE_NAME "KOPIC.HLP"
#define IDH_OVERVIEW 103
#define KB 1024L
#define KILOBYTES 768L
#define LARGE_NUMBER 2147483647
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT_LINE_COUNT 18
#define PARAMETER_SIZE 256
#define TWO_DIGIT_NUMBER 99
#include <math.h>
#include "Feedable.h"
#include "NAMES.h"
#include "Numbered.h"
#include "OS-specific.h"
#include "PRNG.h"

typedef struct MANAGE_MEMO MANAGE_MEMO;
struct MANAGE_MEMO {
    bool checkBox, countBonus, csv, editor, firstLine, grouping, mark, noSplitting, onlyTwo, pleaseCheck, preedit, produce_rannu_text, quit, serialNumber, showWhere, statusBar, threeLinesUnited, whoCSV, whoText;
    int balls, csv_h, csv_w, csv_x, csv_y, from, interval_0, interval_1, lineCount, prng, rowCount, whichCorner, zoko_h, zoko_w, zoko_x, zoko_y;
    long kilo, seed;
    std::string fileName, FULL_PATH_NAME, list_of_items, pathName, secondLine, textName, whoTextLine1;
    std::string a[DRAW_ARRAY_SIZE];
    std::string draw[DRAW_ARRAY_SIZE];
};

class RandomNumber {
    const std::string COMMA, GAP, m00, m01, m02, m03, m04, m05, m06, m07, m08, m09, m10, m11, m12, m13, m14, m15, m16, m17, m18, m19, m20, m21, m22, m23, m24, m25, m26, m27, m28, m29, m30, m31, m32, m33, m34, m35, m36, m37, m38, m39, m40, m41, m42, m43, m44, m45, m46, m47, m48, m49, m50, m51, m52, m53, m54, m55, m56, m57, m58, m59, m60, m61, m62, m63, m64, m65, m66, m67, m68, m69, m70, m71, m72, m73, m74, m75, m76, m77, m78, m79, m80, m81, m82, m83, m84, m85, m86, m87, m88, m89, m90, m91, m92, m93, m94, m95, m96, m97, m98, m99, RANNU_CSV, RANNU_TXT;
    bool csv, grouping, produce_rannu_text;
    std::string rannuText, separator;
    int from, interval_0, interval_1, lineCount, prng;
    PRNG *prn;
    long kilo, seed;
    std::string b[ TWO_DIGIT_NUMBER + 1 ];

public:
    ~RandomNumber() {
        delete prn;
    }

    RandomNumber(long k, long s, int f, int i0, int i1, int l, int p, bool c, bool g, bool pr);

    unsigned int random_integer() {
        return prn->nextRandom();
    }

    bool createRannuText(std::string & pathName);
    void setPRNG();
};

bool createRemoveErrorText();
int integerFromString(std::string & s);
NAMES driveDirectoryBase(std::string & s);
void guide(bool comments);

#endif // RANNU_TEXT_H
