#include <vcl.h>
#pragma hdrstop

#include "zokoCSV.h"

#pragma resource "*.dfm"
extern MANAGE_MEMO *mm;
TOKBottomDlg *OKBottomDlg;

bool TOKBottomDlg::readCSV(std::string & file_name) {
    using namespace std;

    ifstream in( file_name.c_str() );
    if( in.fail() ) {
        error = "e38: ifstream in( " + file_name + CLOSE_BRACKET;
        return false;
    }

    textName = file_name;
    const AnsiString CSV_FILE_NAME( file_name.c_str() );
    Label1->Caption = CSV_FILE_NAME;

// Reading and sorting
    char c[BUFFER_SIZE];
    priority_queue<string> pq;
    string *p = new string("");
    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        pq.push(*p);
    }

// Tabulating sorted items
    AnsiString *as = new AnsiString("");
    const bool VARIOUS = false;
    int line = 0;
    int m = 0;
    string s("");
    DividingCSV *d = new DividingCSV(s, VARIOUS);
    string b;
    while(! pq.empty() ) {
        s = pq.top();

        delete d;
        d = new DividingCSV(s, VARIOUS);
        for (int i = 0; i < COLUMN_COUNT; ++i) {
            b = d->a(i);
            delete as;
            as = new AnsiString( b.c_str() );
            StringGrid1->Cells[i][m] = *as;
        }

        ++m;
        if(++line > rowCount) {
            break;
        }

        pq.pop();
    }

    delete as;
    delete d;
    delete p;
    return true;
}

bool TOKBottomDlg::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e37: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    stringArrayToValues();
    delete p;
    return true;
}

int integerFromString(std::string & s) {
    using namespace std;

    int value;
    stringstream ss(s);
    ss >> value;
    return value;
}

int TOKBottomDlg::width1(int c) { // Loto-7
    int width = NARROW_LOTO_7;

    if(fullDate) {
        if(c > threshold_of_loto_7) {
            const int CLIENT_WIDTH_THRESHOLD = c - threshold_of_loto_7;
            width += CLIENT_WIDTH_THRESHOLD;
            if(width > LOTO_7_WIDTH) {
                width = LOTO_7_WIDTH;
                fullLoto7 = true;
            } else {
                fullLoto7 = false;
            }

        } else {
            fullLoto7 = false;
        }

    } else {
        fullLoto7 = false;
    }

    return width;
}

int TOKBottomDlg::width3(int c) { // Date
    int width = NARROW_DATE;

    if(c > threshold_of_date) {
        const int CLIENT_WIDTH_THRESHOLD = c - threshold_of_date;
        width += CLIENT_WIDTH_THRESHOLD;
        if(width > DATE_WIDTH) {
            width = DATE_WIDTH;
            fullDate = true;
        } else {
            fullDate = false;
        }

    } else {
        fullDate = false;
    }

    return width;
}

int TOKBottomDlg::width6(int c) { // Name
    int width = NARROW_NAME;

    if(fullLoto7) {
        if(c > threshold_of_name) {
            const int CLIENT_WIDTH_THRESHOLD = c - threshold_of_name;
            width += CLIENT_WIDTH_THRESHOLD;
        }

    }

    return width;
}

void TOKBottomDlg::setting(std::string & f, int r) {
    CheckBox1->Visible = checkBox;
    if(checkBox) {
        if(CheckBox1->Checked) {
            Left = csv_x;
            Top = csv_y;
            Width = csv_w;
            Height = csv_h;
        }

    }

    FULL_PATH_NAME = f;
    rowCount = r;
    if(Visible) {
        mm->csv = false;
    }

    const int ADJUSTER = 0;
    int client_width = ClientWidth - ADJUSTER;
    int statusBarTop = Label1->Top;
    int buttonTop = statusBarTop - LABEL1_CLOSE_TOP;

// check box based on MANAGE_TEXT
    CheckBox1->Top = buttonTop;

// Close button
    CancelBtn->Top = buttonTop;

// PDF button
    OKBtn->Top = buttonTop;

// grid
    StringGrid1->Width = client_width;
    gridBottom = statusBarTop - LABEL1_GRID_BOTTOM;
    StringGrid1->Height = gridBottom - HEADER_HEIGHT;
    StringGrid1->RowCount = rowCount;

// header
    if(sectionResized) { // timer
        tracking();
    } else {
// column widths
        HeaderControl1->Sections->Items[0]->Width = BALLS_WIDTH;
        HeaderControl1->Sections->Items[2]->Width = QP_WIDTH;
        HeaderControl1->Sections->Items[4]->Width = ID_WIDTH;
        HeaderControl1->Sections->Items[5]->Width = RES_NUMBER_WIDTH;
        HeaderControl1->Sections->Items[3]->Width = width3(client_width); // Date
        HeaderControl1->Sections->Items[1]->Width = width1(client_width); // Loto-7
        HeaderControl1->Sections->Items[6]->Width = width6(client_width); // Name
        tracking();
    }

}

void TOKBottomDlg::stringArrayToValues() {
    using namespace std;

    fileName = m[1];
    list_of_items = m[2];
    balls = integerFromString(m[3]);

    editor = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = integerFromString(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    mark = (ZERO == m[10]) ? false : true;
    whoText = (ZERO == m[11]) ? false : true;
    threeLinesUnited = (ZERO == m[12]) ? false : true;
    whichCorner = integerFromString(m[13]);

    csv_x = integerFromString(m[14]);
    csv_y = integerFromString(m[15]);
    csv_w = integerFromString(m[16]);
    csv_h = integerFromString(m[17]);
    checkBox = (ZERO == m[18]) ? false : true;

    mm->checkBox = checkBox;
    mm->csv = false;
    mm->csv_h = csv_h;
    mm->csv_w = csv_w;
    mm->csv_x = csv_x;
    mm->csv_y = csv_y;
    mm->editor = editor;
    mm->fileName = fileName;
    mm->firstLine = firstLine;
    mm->FULL_PATH_NAME = FULL_PATH_NAME;
    mm->balls = balls;
    mm->list_of_items = list_of_items;
    mm->mark = mark;
    mm->threeLinesUnited = threeLinesUnited;
    mm->noSplitting = noSplitting;
    mm->pleaseCheck = true;
    mm->preedit = preedit;
    mm->rowCount = rowCount;
    mm->serialNumber = serialNumber;
    mm->textName = textName;
    mm->whichCorner = whichCorner;
    mm->whoText = whoText;
}

void TOKBottomDlg::tracking() {
    const int A_LINE = 1;

    for(int i = 0; i < COLUMN_COUNT; ++i) {
        StringGrid1->ColWidths[i] = HeaderControl1->Sections->Items[i]->Width - A_LINE;
    }

}

__fastcall TOKBottomDlg::TOKBottomDlg(TComponent* AOwner)
	: TForm(AOwner), BALLS("Balls"), CLOSE_BRACKET(" )"), COMBO("Loto-7"), DATE("Date"), FULL_PATH_NAME("C:\\zokoVCL\\manage.txt"), ID("ID"), m0(""), m1("who.txt"), m10("0"), m11("0"), m12("0"), m13("0"), m14("20"), m15("20"), m16("800"), m17("600"), m18("1"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), NAME("Name"), QP("QP"), RES_NUMBER("Res-Number"), ZERO("0") 
{
    csv_x = 20;
    csv_y = 20;
    csv_w = 800;
    csv_h = 600;
    fullLoto7 = false;
    fullDate = false;
    rowCount = CSV_LINE_COUNT;

    Bevel1->Visible = false;
    CancelBtn->Left = CSV_CLOSE_LEFT;
    CancelBtn->Width = BUTTON_WIDTH;
    CancelBtn->Height = BUTTON_HEIGHT;
    CheckBox1->Left = CSV_CHECK_BOX_LEFT;
    OKBtn->Left = CSV_HELP_LEFT;
    OKBtn->Width = BUTTON_WIDTH;
    OKBtn->Height = BUTTON_HEIGHT;
    Position = poDesigned;

    Left = csv_x;
    Top = csv_y;
    Width = csv_w;
    Height = csv_h;
    narrow_name = NARROW_NAME - SCROLL_BAR_WIDTH;

    const int ADJUSTER = 8;
    int client_width = ClientWidth - ADJUSTER;

    threshold_of_date = ID_WIDTH + BALLS_WIDTH + QP_WIDTH + RES_NUMBER_WIDTH + NARROW_LOTO_7 + NARROW_DATE + NARROW_NAME;
    threshold_of_loto_7 = ID_WIDTH + BALLS_WIDTH + QP_WIDTH + RES_NUMBER_WIDTH + NARROW_LOTO_7 + DATE_WIDTH + NARROW_NAME;
    threshold_of_name = ID_WIDTH + BALLS_WIDTH + QP_WIDTH + RES_NUMBER_WIDTH + LOTO_7_WIDTH + DATE_WIDTH + NARROW_NAME;

    HeaderControl1->Align = alTop;
    HeaderControl1->Height = HEADER_HEIGHT;
    HeaderControl1->Sections->Items[0]->Width = BALLS_WIDTH;
    HeaderControl1->Sections->Items[2]->Width = QP_WIDTH;
    HeaderControl1->Sections->Items[4]->Width = ID_WIDTH;
    HeaderControl1->Sections->Items[5]->Width = RES_NUMBER_WIDTH;
    HeaderControl1->Sections->Items[3]->Width = width3(client_width); // Date
    HeaderControl1->Sections->Items[1]->Width = width1(client_width); // Loto-7
    HeaderControl1->Sections->Items[6]->Width = width6(client_width); // Name

    HeaderControl1->Sections->Items[0]->Text = BALLS;
    HeaderControl1->Sections->Items[1]->Text = COMBO;
    HeaderControl1->Sections->Items[2]->Text = QP;
    HeaderControl1->Sections->Items[3]->Text = DATE;
    HeaderControl1->Sections->Items[4]->Text = ID;
    HeaderControl1->Sections->Items[5]->Text = RES_NUMBER;
    HeaderControl1->Sections->Items[6]->Text = NAME;

    StringGrid1->BorderStyle = bsNone;
    StringGrid1->DefaultRowHeight = GRID_ROW_HEIGHT;
    StringGrid1->FixedCols = 0;
    StringGrid1->FixedRows = 0;
    StringGrid1->GridLineWidth = 1;
    StringGrid1->Left = 0;
    StringGrid1->RowCount = rowCount;
    StringGrid1->ScrollBars = ssBoth;
    StringGrid1->Top = HEADER_HEIGHT;
    tracking();

    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; m[13] = m13; m[14] = m14; m[15] = m15; m[16] = m16; m[17] = m17; m[18] = m18;
    CheckBox1->State = cbChecked;
    checkBox = mm->checkBox;
    untouched = modified_file(MANAGE_TEXT);
    Timer1->Interval = NON_SAMPLING_PERIOD_FOR_CSV_WINDOW;
}

void __fastcall TOKBottomDlg::OKBtnClick(TObject *Sender)
{
    executeProgram(VIEW_PDF, "");
}

void __fastcall TOKBottomDlg::HeaderControl1SectionResize(
      THeaderControl *HeaderControl, THeaderSection *Section)
{
    sectionResized = true;
    tracking();
}

void __fastcall TOKBottomDlg::Timer1Timer(TObject *Sender)
{
// Checking if MANAGE_TEXT has been modified
    int m = modified_file(MANAGE_TEXT);
    if(m != untouched) {
        untouched = m;
        readManageText();
        sectionResized = false;
    }

    setting(mm->FULL_PATH_NAME, mm->rowCount);
}

void __fastcall TOKBottomDlg::Label1Click(TObject *Sender)
{
    mm->statusBar = true;
    Close();
}
