/*
Zoko VCL Version 1.11
Finding Loto-7 winners
Copyright 2017 Sogaya

C++Builder 5

*/

#include <vcl.h>
#pragma hdrstop

#include "TableCsv.h"
#include "zokoCSV.h"
#include "zokoMain.h"
#include "zokoVersion.h"
#include "zokoWeight.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

char NO_BLOCK[KOPIC_KUN_SIZE];
extern bool EX_OR_array[XBM_HEIGHT][XBM_WIDTH];
extern bool xbm_boolean_array[XBM_HEIGHT][XBM_WIDTH];
extern char CSVname[FILE_NAME_SIZE];
extern KUN_CODE *kunCode;
extern TOKBottomDlg *OKBottomDlg;
extern TOKHelpRightDlg *OKHelpRightDlg;
extern TOKRightDlg1 *OKRightDlg1;
int unhandled, untouched;
MANAGE_MEMO manage_memo; // rannuText.h
MANAGE_MEMO *mm = &manage_memo;
TForm1 *Form1;

bool TForm1::CSVdialog() {
    bool result;
    std::string preedited;

    if(preedit) {
        EditCount *ec = new EditCount();
        ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
        if( ec->preediting() ) {
            preedited = ec->saved();
        } else {
            error = ec->inquiry();
            createErrorText(error);
            return false;
        }

        delete ec;
    }

    TableCsv *tc = new TableCsv(rowCount, serialNumber, whoText);
    if( tc->run(preedited) ) {
        textName = tc->saved();
        statusBarMessage(textName);

        OKBottomDlg->readManageText();
        mm->textName = textName;

// Producing a scrollable table from CSV
        OKBottomDlg->setting(FULL_PATH_NAME, rowCount);
        OKBottomDlg->readCSV(mm->textName);
        OKBottomDlg->ShowModal();
        if(mm->statusBar) { // TOKBottomDlg::Label1Click()
            const AnsiString TEXT_NAME( mm->textName.c_str() );
            Memo1->Text = TEXT_NAME;
            mm->statusBar = false;
        }

        result = true;
    } else {
        error = tc->inquiry();
        createErrorText(error);
        result = false;
    }

    delete tc;
    return result;
}

bool TForm1::editCountBalls() {
    csv = false;
    mm->csv = false;
    quit = false;
    mm->quit = false;

    bool result;
    EditCount *ec = new EditCount();
    ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
    if( ec->editCount() ) {
        textName = ec->saved();

        statusBarMessage(textName);
        header(textName); // text area
        result = true;
    } else {
        error = ec->inquiry();
        createErrorText(error);
        result = false;
    }

    delete ec;
    return result;
}

bool TForm1::header(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e10: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    stringstream os;
    char buffer[BUFFER_SIZE];
    for(int i = 0; i < FIRST_PART_OF_FILE; ++i) {
        if( in.getline(buffer, BUFFER_SIZE) ) {
            os << buffer << TEXT_AREA_NEW_LINE;
        } else {
            break;
        }

    }

    string s = os.str();

    const AnsiString MEMO_TEXT( s.c_str() );
    Memo1->Text = MEMO_TEXT;
    string PATH_NAME( fileName.c_str() );
    statusBarMessage(PATH_NAME);
    return true;
}

bool TForm1::kopicCsvTouched() {
    using namespace std;

// Checking if KOPIC_CSV exists
    ifstream csv(KOPIC_CSV);
    if( csv.fail() ) {
        return true;
    } else {
        csv.close();
    }

// Checking if KOPIC_CSV has been modified
    bool b = true;
    int m = modified_file(KOPIC_CSV);
    if(m == untouched) {
        b = false;
    } else {
        untouched = m;
    }

    return b;
}

bool TForm1::optionalAdding() {
    using namespace std;

    Optional *p = new Optional(FULL_PATH_NAME, OPTIONAL_TEXT);
    oc = p->readOptionalText();
    if(oc.optional[0] == EMPTY) {
        error = "e39: oc.optional[0] == EMPTY";
        createErrorText(error);
        return false;
    } else {
        statusBarMessage(OPTIONAL_TEXT);

        AnsiString *as = new AnsiString("");
        const int COMMAND_SIZE = 4;
        string s;
        for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
            s = oc.optional[i];
            if( s.length() < COMMAND_SIZE ) {
                break;
            }

            delete as;
            as = new AnsiString( s.c_str() );
            ComboBox1->Items->Add(*as);
            itemCount += 1;
        }

        delete as;
    }

    ComboBox1->ItemIndex = itemCount - 1;
    delete p;
    return true;
}

bool TForm1::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e11: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    stringArrayToValues();
    delete p;
    return true;
}

bool TForm1::setLine(int line_number) {
    using namespace std;

    bool b = true;;
    const std::string ONE("1");
    if( readManageText() ) {
        m[line_number] = ONE;

// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

    } else {
        b = false;
    }

    return b;
}

int modified_file(const char *file_name) {
    AnsiString FILE_NAME(file_name);
    return FileAge(FILE_NAME);
}

void TForm1::centering() {
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 0;

    const int SCREEN_WIDTH = Screen->Width;
    const int SCREEN_HEIGHT = Screen->Height;

    Left = SCREEN_WIDTH/2 - Width/2;
    Top = SCREEN_HEIGHT/2 - Height/2;

    standard_main_x = Left;
    standard_main_y = Top;
    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void TForm1::checkManageMemory() {
    if(mm->pleaseCheck) {
        balls = mm->balls;
        checkBox = mm->checkBox;
        csv = mm->csv;
        csv_h = mm->csv_h;
        csv_w = mm->csv_w;
        csv_x = mm->csv_x;
        csv_y = mm->csv_y;
        editor = mm->editor;
        fileName = mm->fileName;
        firstLine = mm->firstLine;
        FULL_PATH_NAME = mm->FULL_PATH_NAME;
        grouping = mm->grouping;
        interval_0 = mm->interval_0;
        interval_1 = mm->interval_1;
        kilo = mm->kilo;
        lineCount = mm->lineCount;
        list_of_items = mm->list_of_items;
        mark = mm->mark;
        noSplitting = mm->noSplitting;
        pathName = mm->pathName;

        preedit = mm->preedit;
        prng = mm->prng;
        produce_rannu_text = mm->produce_rannu_text;
        threeLinesUnited = mm->threeLinesUnited;
        zoko_h = mm->zoko_h;
        zoko_w = mm->zoko_w;
        zoko_x = mm->zoko_x;
        zoko_y = mm->zoko_y;
        rowCount = mm->rowCount;
        seed = mm->seed;
        serialNumber = mm->serialNumber;
        textName = mm->textName;
        whichCorner = mm->whichCorner;
        whoCSV = mm->whoCSV;
        whoText = mm->whoText;
        whoTextLine1 = mm->whoTextLine1;

        mm->pleaseCheck = false;
    }

}

void TForm1::largeHandler() {
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 1;

    Top = CORNER_X;
    Left = CORNER_Y;
    Width = LARGE_PANE_X;
    Height = LARGE_PANE_Y;

    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void TForm1::memoText() {
    const AnsiString TEXT_NAME( statusBarText.c_str() );
    Memo1->Text = TEXT_NAME;
}

void TForm1::settingComboBox() {
    using namespace std;

    const int COMBO_BOX_ITEM_COUNT = 10;
    const int BALLS = 4;
    const string BONUS_SIX("Count six and bonus balls.");
    const string BONUS_THREE("Count three and bonus balls.");
    const string COUNT_EIGHT("Count Eight");
    const string COUNT_FIVE("Count Five");
    const string COUNT_FOUR("Count Four");
    const string COUNT_ONE("Count One");
    const string COUNT_SEVEN("Count Seven");
    const string COUNT_SIX("Count Six");
    const string COUNT_THREE("Count Three");
    const string COUNT_TWO("Count Two");
    const string SEVERAL_HYPHENS("-----------");
    string COMBO_BOX_ITEM[COMBO_BOX_ITEM_COUNT];
    COMBO_BOX_ITEM[0] = COUNT_ONE;
    COMBO_BOX_ITEM[1] = COUNT_TWO;
    COMBO_BOX_ITEM[2] = COUNT_THREE;
    COMBO_BOX_ITEM[3] = BONUS_THREE;
    COMBO_BOX_ITEM[4] = COUNT_FOUR; // BALLS = 4
    COMBO_BOX_ITEM[5] = COUNT_FIVE;
    COMBO_BOX_ITEM[6] = COUNT_SIX;
    COMBO_BOX_ITEM[7] = BONUS_SIX;
    COMBO_BOX_ITEM[8] = COUNT_SEVEN;
    COMBO_BOX_ITEM[9] = SEVERAL_HYPHENS;

    AnsiString *p = new AnsiString("");
    ComboBox1->Clear();
    ComboBox1->DropDownCount = 36;
    ComboBox1->Style = csDropDownList;
    itemCount = 0;
    for(int i = 0; i < COMBO_BOX_ITEM_COUNT; ++i) {
        delete p;
        p = new AnsiString( COMBO_BOX_ITEM[i].c_str() );
        ComboBox1->Items->Add(*p);
        itemCount += 1;
    }

    ComboBox1->ItemIndex = BALLS;
    delete p;
}

void TForm1::standardHeader(bool perfect) {
    WindowState = wsNormal;
    checkManageMemory();

    if(perfect) {
        whichCorner = 0;
        mm->whichCorner = 0;
        Left = standard_main_x;
        Top = standard_main_y;
    }

    Height = MAIN_HEIGHT;
    Width = MAIN_WIDTH;

// Moving the Rannu window
    const int SCREEN_WIDTH = Screen->Width;
    const int SCREEN_HEIGHT = Screen->Height;

    switch(whichCorner) {
    case 1:
        Left = 0;
        Top = 0;
        break;
    case 2:
        Left = SCREEN_WIDTH - Width;
        Top = 0;
        break;
    case 3:
        Left = SCREEN_WIDTH - Width;
        Top = SCREEN_HEIGHT - Height - TASK_BAR_HEIGHT;
        break;
    case 4:
        Left = 0;
        Top = SCREEN_HEIGHT - Height - TASK_BAR_HEIGHT;
        break;
    default:
        Left = SCREEN_WIDTH/2 - Width/2;
        Top = SCREEN_HEIGHT/2 - Height/2;
        break;
    }

    if(perfect) {
        standard_main_x = Left;
        standard_main_y = Top;
    }

    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void TForm1::statusBarMessage(std::string & s) {
    statusBarText = s;
    const AnsiString MESSAGES( s.c_str() );
    StatusBar1->Panels->Items[0]->Text = MESSAGES;
}

void TForm1::stringArrayToValues() {
    using namespace std;

    fileName = m[1];
    list_of_items = m[2];
    balls = integerFromString(m[3]);

    editor = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = integerFromString(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    mark = (ZERO == m[10]) ? false : true;
    whoText = (ZERO == m[11]) ? false : true;
    threeLinesUnited = (ZERO == m[12]) ? false : true;
    whichCorner = integerFromString(m[13]);

    csv_x = integerFromString(m[14]);
    csv_y = integerFromString(m[15]);
    csv_w = integerFromString(m[16]);
    csv_h = integerFromString(m[17]);
    checkBox = (ZERO == m[18]) ? false : true;

    mm->checkBox = checkBox;
    mm->csv = false;
    mm->csv_h = csv_h;
    mm->csv_w = csv_w;
    mm->csv_x = csv_x;
    mm->csv_y = csv_y;
    mm->editor = editor;
    mm->fileName = fileName;
    mm->firstLine = firstLine;
    mm->FULL_PATH_NAME = FULL_PATH_NAME;
    mm->balls = balls;
    mm->list_of_items = list_of_items;
    mm->mark = mark;
    mm->noSplitting = noSplitting;
    mm->pleaseCheck = true;
    mm->preedit = preedit;
    mm->rowCount = rowCount;
    mm->serialNumber = serialNumber;
    mm->textName = textName;
    mm->threeLinesUnited = threeLinesUnited;
    mm->whichCorner = whichCorner;
    mm->whoText = whoText;
}

void TForm1::temporaryFileName(char *name) {
    std::string TEMPORARY_FILE_NAME(name);
    statusBarMessage(TEMPORARY_FILE_NAME);
}

void TForm1::tracking() {
    const int ADJUSTER = 1;
    const int CLIENT_WIDTH = ClientWidth - ADJUSTER;
    const int MID = ClientWidth/2;

// command
    ComboBox1->Width = MID;

// Count button
    Button1->Left = MID;

// Large button
    Button2->Left = CLIENT_WIDTH - BUTTON_WIDTH;
}

bool TForm1::where() {
    using namespace std;

    const int ADJUSTER = 73;
    const int BORDER = 5;
    const string INSIDE("inside");
    const string OUTSIDE("outside");
    POINT pos;

    ::GetCursorPos(&pos);

    bool inside = false;
    int upper_left_x = Left + BORDER;
    int upper_left_y = Top + ADJUSTER;
    int upper_right_x = upper_left_x + ClientWidth;
    int lower_left_y = upper_left_y + ClientHeight - BUTTON_HEIGHT - StatusBar1->Height;
    string here = OUTSIDE;
    if(upper_left_x < pos.x && pos.x < upper_right_x) {
        if(upper_left_y < pos.y && pos.y < lower_left_y) {
            here = INSIDE;
            inside = true;
        }

    }

    stringstream os;
    os << pos.x << " : " << pos.y << " ( " << here << " ) ";
    string s = os.str();
    const AnsiString XY_OUTSIDE( s.c_str() );
    StatusBar1->Panels->Items[1]->Text = XY_OUTSIDE;
    return inside;
}

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner), BALLS(4), CLOSE_BRACKET(" )"), DRAFO_CSV("drafo.csv"), EMPTY(""), FULL_PATH_NAME("C:\\zokoVCL\\manage.txt"), GAP(" "), IMPERFECT(false), m0(""), m1("who.txt"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), m10("0"), m11("0"), m12("0"), m13("0"), m14("20"), m15("20"), m16("800"), m17("600"), m18("1"), OPTIONAL_TEXT("optional.txt"), PERFECT(true), TEXT_AREA_NEW_LINE("\x0D\x0A"), TEXT_AREA_NEW_LINE_LENGTH(2), TITLE("Zoko"), ZERO("0")
{
    const AnsiString CSV_NAME(CSVname);
    KeyPreview = true;
    Height = MAIN_HEIGHT;
    Width = MAIN_WIDTH;
    Left = MAIN_X;
    Top = MAIN_Y;
    Position = poDesigned;

    Panel1->Align = alTop;
    Panel1->Height = BUTTON_HEIGHT;
    StatusBar1->Panels->Items[0]->Text = CSV_NAME;
    StatusBar1->Panels->Items[1]->Text = "";
    Memo1->Align = alClient;

    Button1->Height = BUTTON_HEIGHT;
    Button1->Width = BUTTON_WIDTH;
    Button2->Height = BUTTON_HEIGHT;
    Button2->Width = BUTTON_WIDTH;
    tracking();

    balls = mm->balls;
    checkBox = mm->checkBox;
    countBonus = mm->countBonus;
    csv = false;
    csv_h = mm->csv_h;
    csv_w = mm->csv_w;
    csv_x = mm->csv_x;
    csv_y = mm->csv_y;
    editor = mm->editor;
    fileName = mm->fileName;
    firstLine = mm->firstLine;
    FULL_PATH_NAME = mm->FULL_PATH_NAME;
    list_of_items = mm->list_of_items;
    mark = mm->mark;
    mm->csv = false;
    mm->pleaseCheck = false;
    mm->quit = false;
    noSplitting = mm->noSplitting;
    onlyTwo = mm->onlyTwo;
    preedit = mm->preedit;
    quit = false;
    rowCount = mm->rowCount;
    serialNumber = mm->serialNumber;
    showWhere = mm->showWhere;
    textName = mm->textName;
    threeLinesUnited = mm->threeLinesUnited;
    whichCorner = mm->whichCorner;
    whoText = mm->whoText;
    whoTextLine1 = mm->whoTextLine1;

    header(textName);
    settingComboBox();
    standardHeader(IMPERFECT);

    firstSession = true;
    unhandled = 0;
    untouched = modified_file(KOPIC_CSV);
    Timer1->Interval = NON_SAMPLING_PERIOD;
}

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
}

void __fastcall TForm1::Version1Click(TObject *Sender)
{
    OKHelpRightDlg->setVersion(VERSION);
    OKHelpRightDlg->ShowModal();
}

void __fastcall TForm1::Weight1Click(TObject *Sender)
{
    OKRightDlg1->ShowModal();
}

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    using namespace std;

    checkManageMemory();

    if(showWhere) {
// Showing where the cursor is
        where();
    }

    if( kopicCsvTouched() ) {
        PICK_CODE pc = OKRightDlg1->setting(KOPIC_CSV, kunCode);
        if(pc.code != UNPICKED) {
            ofstream file(ERROR_TEXT);
            file << "kopicCsvTouched(): pc.code != UNPICKED" << endl;

            Application->Terminate();
        }

    }

// Checking if MANAGE_TEXT has been modified
    bool perused = false;
    int m = modified_file(MANAGE_TEXT);
    if(m != unhandled) {
        unhandled = m;
        perused = readManageText();
    }

    if(firstSession) {
        Memo1->SetFocus();
        firstSession = false;
    } else {
        if(perused) {
            statusBarMessage(FULL_PATH_NAME);
        }

    }

}

void __fastcall TForm1::CSV1Click(TObject *Sender)
{
    CSVdialog();
}

void __fastcall TForm1::FormResize(TObject *Sender)
{
    tracking();
}

void __fastcall TForm1::Button2Click(TObject *Sender)
{
    largeHandler();
}

void __fastcall TForm1::Large1Click(TObject *Sender)
{
    largeHandler();
}

void __fastcall TForm1::Standard1Click(TObject *Sender)
{
    standardHeader(PERFECT);
}

void __fastcall TForm1::StatusBar1Click(TObject *Sender)
{
    memoText();
}

void __fastcall TForm1::Center1Click(TObject *Sender)
{
    centering();
}

void __fastcall TForm1::Corner1Click(TObject *Sender)
{
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 1;

    Top = 0;
    Left = 0;
    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void __fastcall TForm1::Diagonal1Click(TObject *Sender)
{
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 3;

    const int SCREEN_WIDTH = Screen->Width;
    const int SCREEN_HEIGHT = Screen->Height;

    Left = SCREEN_WIDTH - Width;
    Top = SCREEN_HEIGHT - Height - TASK_BAR_HEIGHT;
    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void __fastcall TForm1::Right1Click(TObject *Sender)
{
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 2;

    const int SCREEN_WIDTH = Screen->Width;
    Left = SCREEN_WIDTH - Width;
    Top = 0;
    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void __fastcall TForm1::Small1Click(TObject *Sender)
{
    WindowState = wsNormal;

    Height = SMALL_PANE_HEIGHT;
    Width = SMALL_PANE_WIDTH;

    mm->zoko_h = Height;
    mm->zoko_w = Width;
    mm->pleaseCheck = true;
    centering();
}

void __fastcall TForm1::Under1Click(TObject *Sender)
{
    WindowState = wsNormal;
    checkManageMemory();
    whichCorner = 4;

    const int SCREEN_HEIGHT = Screen->Height;
    Left = 0;
    Top = SCREEN_HEIGHT - Height - TASK_BAR_HEIGHT;
    mm->zoko_x = Left;
    mm->zoko_y = Top;
    mm->zoko_w = Width;
    mm->zoko_h = Height;
    mm->whichCorner = whichCorner;
    mm->pleaseCheck = true;
}

void __fastcall TForm1::Editor1Click(TObject *Sender)
{
    setLine(4);
    executeProgram(EDITOR_WINDOW, "");    
}

void __fastcall TForm1::Mark1Click(TObject *Sender)
{
    setLine(10);
    executeProgram(MARK_WINDOW, "");
}

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    using namespace std;

    readManageText();
    m[4] = ZERO;
    m[10] = ZERO;

// Creating MANAGE_TEXT
    ofstream manage_text( FULL_PATH_NAME.c_str() );
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        manage_text << m[line] << endl;
    }

    createRemoveErrorText();
}

void __fastcall TForm1::Copy1Click(TObject *Sender)
{
    char buffer[BUFFER_SIZE];
    strcpy(buffer, statusBarText.c_str() );
    Clipboard()->SetTextBuf(buffer);
}
void __fastcall TForm1::Three2Click(TObject *Sender)
{
    countBonus = true;
    balls = 3;
    ComboBox1->ItemIndex = 3; // COMBO_BOX_ITEM[3] = BONUS_THREE;
    editCountBalls();
}

void __fastcall TForm1::Six2Click(TObject *Sender)
{
    countBonus = true;
    balls = 6;
    ComboBox1->ItemIndex = 7; // COMBO_BOX_ITEM[7] = BONUS_SIX;
    editCountBalls();
}

void __fastcall TForm1::One1Click(TObject *Sender)
{
    countBonus = false;
    balls = 1;
    ComboBox1->ItemIndex = 0;
    editCountBalls();
}

void __fastcall TForm1::Two1Click(TObject *Sender)
{
    countBonus = false;
    balls = 2;
    ComboBox1->ItemIndex = 1;
    editCountBalls();
}

void __fastcall TForm1::Three1Click(TObject *Sender)
{
    countBonus = false;
    balls = 3;
    ComboBox1->ItemIndex = 2;
    editCountBalls();
}

void __fastcall TForm1::Four1Click(TObject *Sender)
{
    countBonus = false;
    balls = 4;
    ComboBox1->ItemIndex = 4;
    editCountBalls();
}

void __fastcall TForm1::Five1Click(TObject *Sender)
{
    countBonus = false;
    balls = 5;
    ComboBox1->ItemIndex = 5;
    editCountBalls();
}

void __fastcall TForm1::Six1Click(TObject *Sender)
{
    countBonus = false;
    balls = 6;
    ComboBox1->ItemIndex = 6;
    editCountBalls();
}

void __fastcall TForm1::Seven1Click(TObject *Sender)
{
    countBonus = false;
    balls = 7;
    ComboBox1->ItemIndex = 8; // COMBO_BOX_ITEM[8] = COUNT_SEVEN;
    editCountBalls();
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    using namespace std;

    AnsiString as = ComboBox1->Text;
    const string BONUS_3("Count three and bonus balls.");
    const string BONUS_6("Count six and bonus balls.");
    const string COUNT_FIVE("Count Five");
    const string COUNT_FOUR("Count Four");
    const string COUNT_ONE("Count One");
    const string COUNT_SEVEN("Count Seven");
    const string COUNT_SIX("Count Six");
    const string COUNT_THREE("Count Three");
    const string COUNT_TWO("Count Two");
    const string SEVERAL_HYPHENS("-----------");

    string s( as.c_str() );

    balls = BALLS;
    countBonus = false;
    if(s == BONUS_3) {
        balls = 3;
        countBonus = true;
    } else if(s == BONUS_6) {
        balls = 6;
        countBonus = true;
    } else if(s == COUNT_ONE) {
        balls = 1;
    } else if(s == COUNT_TWO) {
        balls = 2;
    } else if(s == COUNT_THREE) {
        balls = 3;
    } else if(s == COUNT_FOUR) {
        balls = 4;
    } else if(s == COUNT_FIVE) {
        balls = 5;
    } else if(s == COUNT_SIX) {
        balls = 6;
    } else if(s == COUNT_SEVEN) {
        balls = 7;
    } else {
        int q = s.find(SEVERAL_HYPHENS);
        if(q != string::npos) {
            return;
        }

        int place = whichCorner;

        Optional *p = new Optional(FULL_PATH_NAME);
        p->command(s);
        balls = mm->balls;
        countBonus = mm->countBonus;
        csv = mm->csv;
        fileName = mm->fileName;
        firstLine = mm->firstLine;
        FULL_PATH_NAME = mm->FULL_PATH_NAME;
        list_of_items = mm->list_of_items;
        noSplitting = mm->noSplitting;
        preedit = mm->preedit;
        quit = mm->quit;
        rowCount = mm->rowCount;
        serialNumber = mm->serialNumber;
        threeLinesUnited = mm->threeLinesUnited;
        whichCorner = mm->whichCorner;
        whoText = mm->whoText;

        if(whichCorner != place) {
            standardHeader(IMPERFECT);
        }

        if(csv) {
            CSVdialog();
            csv = false;
            mm->csv = false;
            return;
        } else {
            mm->csv = false;
        }

        if(quit) {
            EditCount *ec = new EditCount();
            ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
            ec->preediting();
            textName = ec->saved();
            statusBarMessage(textName);
            quit = false;
            mm->quit = false;
            delete ec;
            return;
        } else {
            mm->quit = false;
        }

        delete p;
    }

    editCountBalls();
}

void __fastcall TForm1::Optional1Click(TObject *Sender)
{
    optionalAdding();
}

void __fastcall TForm1::Preediting1Click(TObject *Sender)
{
    EditCount *ec = new EditCount();
    ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
    ec->preediting();
    textName = ec->saved();
    statusBarMessage(textName);
    quit = false;
    mm->quit = false;
    delete ec;
}

void __fastcall TForm1::ComboBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	switch(Key) {
	case VK_SPACE:
        optionalAdding();    
        break;
    default:
        break;
    }

}

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	switch(Key) {
	case VK_SPACE:
        optionalAdding();    
        break;
    default:
        break;
    }

}

void __fastcall TForm1::Minimize1Click(TObject *Sender)
{
    Application->Minimize();
}
