#include <vcl.h>
#pragma hdrstop

#include "zokoWeight.h"
#pragma resource "*.dfm"

extern char *random_number;
extern int untouched;
extern KUN_CODE *kunCode;
extern MANAGE_MEMO *mm;
TOKRightDlg1 *OKRightDlg1;

PICK_CODE TOKRightDlg1::setting(const char *f, KUN_CODE *p) {
    using namespace std;

    bool check[100]; // 0 to 99
    bool csv = mm->csv;
    bool grouping = mm->grouping;
    bool produce_rannu_text = mm->produce_rannu_text;
    bool rannu_text_required, wide_range;
    int b;
    int interval_0 = mm->interval_0;
    int interval_1 = mm->interval_1;
    int lineCount = mm->lineCount;
    int prng = mm->prng;
    long kilo = mm->kilo;
    long table_size = 1L;
    PICK_CODE pc;
    RandomNumber *rn;

    mapping = p->mapping;
    weight = p->weight;
    strcpy(pc.file_name, f);

    if(p->defectiveCsv) {
// Reading a CSV file to produce KOPIC_CSV
        if(! readCsv(pc.file_name, p) ) {
            pc.code = NO_CSV;
            return pc;
        }

    }

    if(p->full_swing) {
// Rewriting KOPIC_CSV and creating KOPIC_TEXT
        fullSwing(KOPIC_CSV);
    }

// Reading KOPIC_CSV
    Pickable *k;
    if(p->weight) {
        if(p->mapping) {
            k = new Mapping();
            rannu_text_required = true;
            wide_range = false;
        } else {
            if(p->grouping) {
                k = new Tint();
                rannu_text_required = true;
                wide_range = true;
            } else {
                k = new Weight();
                rannu_text_required = false;
                wide_range = false;
            }

        }

    } else {
        k = new Transparent();
        rannu_text_required = true;
        wide_range = false;
    }

    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int count = k->comboCount();
    int from = k->idling();
    long seed = (long)k->seedData();
    if(seed == 0L) {
        long e = (long)time(NULL);
        seed = e & SEED_MASK;
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();

//        int q = (int) rn->random_integer();
//        int repeat = k->repetition();
//        from += q%repeat;
    } else {
        rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, grouping, produce_rannu_text);
        rn->setPRNG();
    }

    mm->seed = seed;
    if(rannu_text_required) {
        ifstream test(RANDOM_NUMBER_TEXT);
        if( test.fail() ) {
            rn = new RandomNumber(kilo, seed, from, interval_0, interval_1, lineCount, prng, csv, p->grouping, produce_rannu_text);
            rn->createRannuText(mm->pathName);
        } else {
            test.close();
        }

// Reading RANDOM_NUMBER_TEXT to produce a random-number array
        setTwoDigitNumbers(); // two_digit_number[][]
        readRannuText(&table_size); // random_number[u]
        k->randomNumberArray(table_size, from);
        if(wide_range) {
            k->wideRange();
        }

    } else {
// Because the function internally produces random numbers, an external random-number table is unnecessary.
        k->internallyProduce(rn); // Weight::function( )

        random_number = new char[MAIN_BUFFER_SIZE];
        memset(random_number, 0, MAIN_BUFFER_SIZE);
        table_size = (long)MAIN_BUFFER_SIZE;
    }

// text fields of the Weight pane
    field[0] = 0;
    for(int i = 1; i <= ALL; ++i) {
        field[i] = k->floor_weight(i);
    }

    field[38] = from;
    field[39] = 0;
    field[40] = from + count;
    field[41] = k->seedData();

    char buffer[VERY_SMALL_BUFFER_SIZE];
    int y = 0;
    string kopicLogText = k->logFileName();

    figures(buffer, field[1]); AnsiString editText1(buffer); Edit1->Text = editText1;
    figures(buffer, field[2]); AnsiString editText2(buffer); Edit2->Text = editText2;
    figures(buffer, field[3]); AnsiString editText3(buffer); Edit3->Text = editText3;
    figures(buffer, field[4]); AnsiString editText4(buffer); Edit4->Text = editText4;
    figures(buffer, field[5]); AnsiString editText5(buffer); Edit5->Text = editText5;
    figures(buffer, field[6]); AnsiString editText6(buffer); Edit6->Text = editText6;
    figures(buffer, field[7]); AnsiString editText7(buffer); Edit7->Text = editText7;
    figures(buffer, field[8]); AnsiString editText8(buffer); Edit8->Text = editText8;
    figures(buffer, field[9]); AnsiString editText9(buffer); Edit9->Text = editText9;
    figures(buffer, field[10]); AnsiString editText10(buffer); Edit10->Text = editText10;
    figures(buffer, field[11]); AnsiString editText11(buffer); Edit11->Text = editText11;
    figures(buffer, field[12]); AnsiString editText12(buffer); Edit12->Text = editText12;
    figures(buffer, field[13]); AnsiString editText13(buffer); Edit13->Text = editText13;
    figures(buffer, field[14]); AnsiString editText14(buffer); Edit14->Text = editText14;
    figures(buffer, field[15]); AnsiString editText15(buffer); Edit15->Text = editText15;
    figures(buffer, field[16]); AnsiString editText16(buffer); Edit16->Text = editText16;
    figures(buffer, field[17]); AnsiString editText17(buffer); Edit17->Text = editText17;
    figures(buffer, field[18]); AnsiString editText18(buffer); Edit18->Text = editText18;
    figures(buffer, field[19]); AnsiString editText19(buffer); Edit19->Text = editText19;
    figures(buffer, field[20]); AnsiString editText20(buffer); Edit20->Text = editText20;
    figures(buffer, field[21]); AnsiString editText21(buffer); Edit21->Text = editText21;
    figures(buffer, field[22]); AnsiString editText22(buffer); Edit22->Text = editText22;
    figures(buffer, field[23]); AnsiString editText23(buffer); Edit23->Text = editText23;
    figures(buffer, field[24]); AnsiString editText24(buffer); Edit24->Text = editText24;
    figures(buffer, field[25]); AnsiString editText25(buffer); Edit25->Text = editText25;
    figures(buffer, field[26]); AnsiString editText26(buffer); Edit26->Text = editText26;
    figures(buffer, field[27]); AnsiString editText27(buffer); Edit27->Text = editText27;
    figures(buffer, field[28]); AnsiString editText28(buffer); Edit28->Text = editText28;
    figures(buffer, field[29]); AnsiString editText29(buffer); Edit29->Text = editText29;
    figures(buffer, field[30]); AnsiString editText30(buffer); Edit30->Text = editText30;
    figures(buffer, field[31]); AnsiString editText31(buffer); Edit31->Text = editText31;
    figures(buffer, field[32]); AnsiString editText32(buffer); Edit32->Text = editText32;
    figures(buffer, field[33]); AnsiString editText33(buffer); Edit33->Text = editText33;
    figures(buffer, field[34]); AnsiString editText34(buffer); Edit34->Text = editText34;
    figures(buffer, field[35]); AnsiString editText35(buffer); Edit35->Text = editText35;
    figures(buffer, field[36]); AnsiString editText36(buffer); Edit36->Text = editText36;
    figures(buffer, field[37]); AnsiString editText37(buffer); Edit37->Text = editText37;
    figures(buffer, field[38]); AnsiString editText38(buffer); Edit38->Text = editText38;
    AnsiString editText39( kopicLogText.c_str() ); Edit39->Text = editText39;
    figures(buffer, field[40]); AnsiString editText40(buffer); Edit40->Text = editText40;
    figures(buffer, field[41]); AnsiString editText41(buffer); Edit41->Text = editText41;

    Edit42->Visible = false;                              
    if(mapping) {
        AnsiString editText42(MAPPING_INDICATOR); Edit42->Text = editText42;
        Edit42->Visible = true;
    } else {
        if(grouping) {
            AnsiString editText42(GROUPING_INDICATOR); Edit42->Text = editText42;
            Edit42->Visible = true;
        } else {
            if(! weight) {
                AnsiString editText42(TRANSPARENT_INDICATOR); Edit42->Text = editText42;
                Edit42->Visible = true;
            }

        }

    }

    delete k;
    delete rn;
    pc.code = UNPICKED;
    return pc;
}

PICK_CODE TOKRightDlg1::textFields() {
    using namespace std;

    char buffer[VERY_SMALL_BUFFER_SIZE];
    int f;
    PICK_CODE pc;

// Reading KOPIC_CSV
    Pickable *k;
    k = new Weight();
    if(! k->readKopicCsv() ) {
        pc.code = DEFECTIVE_CSV;
        return pc;
    }

    int from = k->idling();
    string kopicLogText = k->logFileName();

// text fields of the Weight pane
    field[0] = 0;
    for(int i = 1; i <= ALL; ++i) {
        field[i] = k->floor_weight(i);
    }

    field[38] = from;
    field[39] = 0;
    field[40] = k->repetition();
    field[41] = k->seedData();

    figures(buffer, field[1]); AnsiString editText1(buffer); Edit1->Text = editText1;
    figures(buffer, field[2]); AnsiString editText2(buffer); Edit2->Text = editText2;
    figures(buffer, field[3]); AnsiString editText3(buffer); Edit3->Text = editText3;
    figures(buffer, field[4]); AnsiString editText4(buffer); Edit4->Text = editText4;
    figures(buffer, field[5]); AnsiString editText5(buffer); Edit5->Text = editText5;
    figures(buffer, field[6]); AnsiString editText6(buffer); Edit6->Text = editText6;
    figures(buffer, field[7]); AnsiString editText7(buffer); Edit7->Text = editText7;
    figures(buffer, field[8]); AnsiString editText8(buffer); Edit8->Text = editText8;
    figures(buffer, field[9]); AnsiString editText9(buffer); Edit9->Text = editText9;
    figures(buffer, field[10]); AnsiString editText10(buffer); Edit10->Text = editText10;
    figures(buffer, field[11]); AnsiString editText11(buffer); Edit11->Text = editText11;
    figures(buffer, field[12]); AnsiString editText12(buffer); Edit12->Text = editText12;
    figures(buffer, field[13]); AnsiString editText13(buffer); Edit13->Text = editText13;
    figures(buffer, field[14]); AnsiString editText14(buffer); Edit14->Text = editText14;
    figures(buffer, field[15]); AnsiString editText15(buffer); Edit15->Text = editText15;
    figures(buffer, field[16]); AnsiString editText16(buffer); Edit16->Text = editText16;
    figures(buffer, field[17]); AnsiString editText17(buffer); Edit17->Text = editText17;
    figures(buffer, field[18]); AnsiString editText18(buffer); Edit18->Text = editText18;
    figures(buffer, field[19]); AnsiString editText19(buffer); Edit19->Text = editText19;
    figures(buffer, field[20]); AnsiString editText20(buffer); Edit20->Text = editText20;
    figures(buffer, field[21]); AnsiString editText21(buffer); Edit21->Text = editText21;
    figures(buffer, field[22]); AnsiString editText22(buffer); Edit22->Text = editText22;
    figures(buffer, field[23]); AnsiString editText23(buffer); Edit23->Text = editText23;
    figures(buffer, field[24]); AnsiString editText24(buffer); Edit24->Text = editText24;
    figures(buffer, field[25]); AnsiString editText25(buffer); Edit25->Text = editText25;
    figures(buffer, field[26]); AnsiString editText26(buffer); Edit26->Text = editText26;
    figures(buffer, field[27]); AnsiString editText27(buffer); Edit27->Text = editText27;
    figures(buffer, field[28]); AnsiString editText28(buffer); Edit28->Text = editText28;
    figures(buffer, field[29]); AnsiString editText29(buffer); Edit29->Text = editText29;
    figures(buffer, field[30]); AnsiString editText30(buffer); Edit30->Text = editText30;
    figures(buffer, field[31]); AnsiString editText31(buffer); Edit31->Text = editText31;
    figures(buffer, field[32]); AnsiString editText32(buffer); Edit32->Text = editText32;
    figures(buffer, field[33]); AnsiString editText33(buffer); Edit33->Text = editText33;
    figures(buffer, field[34]); AnsiString editText34(buffer); Edit34->Text = editText34;
    figures(buffer, field[35]); AnsiString editText35(buffer); Edit35->Text = editText35;
    figures(buffer, field[36]); AnsiString editText36(buffer); Edit36->Text = editText36;
    figures(buffer, field[37]); AnsiString editText37(buffer); Edit37->Text = editText37;
    figures(buffer, field[38]); AnsiString editText38(buffer); Edit38->Text = editText38;
    AnsiString editText39( kopicLogText.c_str() ); Edit39->Text = editText39;
    figures(buffer, field[40]); AnsiString editText40(buffer); Edit40->Text = editText40;
    figures(buffer, field[41]); AnsiString editText41(buffer); Edit41->Text = editText41;

    Edit42->Visible = false;                              
    if(mapping) {
        AnsiString editText42(MAPPING_INDICATOR); Edit42->Text = editText42;
        Edit42->Visible = true;
    } else {
        if(grouping) {
            AnsiString editText42(GROUPING_INDICATOR); Edit42->Text = editText42;
            Edit42->Visible = true;
        } else {
            if(! weight) {
                AnsiString editText42(TRANSPARENT_INDICATOR); Edit42->Text = editText42;
                Edit42->Visible = true;
            }

        }

    }

    delete k;
    pc.code = UNPICKED;
    return pc;
}

void figures(char *buffer, int value) {
    using namespace std;

    stringstream os;
    os << value;
    string s = os.str();
    strcpy(buffer, s.c_str() );
}

__fastcall TOKRightDlg1::TOKRightDlg1(TComponent* AOwner)
	: TForm(AOwner)
{
    using namespace std;

    Label1->Top = 38;    Label21->Top = 38;   Edit1->Top = 38;    Edit21->Top = 38;
    Label2->Top = 66;    Label22->Top = 66;   Edit2->Top = 66;    Edit22->Top = 66;
    Label3->Top = 94;    Label23->Top = 94;   Edit3->Top = 94;    Edit23->Top = 94;
    Label4->Top =  122;  Label24->Top = 122;  Edit4->Top =  122;  Edit24->Top = 122;
    Label5->Top =  150;  Label25->Top = 150;  Edit5->Top =  150;  Edit25->Top = 150;
    Label6->Top =  178;  Label26->Top = 178;  Edit6->Top =  178;  Edit26->Top = 178;
    Label7->Top =  206;  Label27->Top = 206;  Edit7->Top =  206;  Edit27->Top = 206;
    Label8->Top =  234;  Label28->Top = 234;  Edit8->Top =  234;  Edit28->Top = 234;
    Label9->Top =  262;  Label29->Top = 262;  Edit9->Top =  262;  Edit29->Top = 262;
    Label10->Top = 290;  Label30->Top = 290;  Edit10->Top = 290;  Edit30->Top = 290;
    Label11->Top = 318;  Label31->Top = 318;  Edit11->Top = 318;  Edit31->Top = 318;
    Label12->Top = 346;  Label32->Top = 346;  Edit12->Top = 346;  Edit32->Top = 346;
    Label13->Top = 374;  Label33->Top = 374;  Edit13->Top = 374;  Edit33->Top = 374;
    Label14->Top = 402;  Label34->Top = 402;  Edit14->Top = 402;  Edit34->Top = 402;
    Label15->Top = 430;  Label35->Top = 430;  Edit15->Top = 430;  Edit35->Top = 430;
    Label16->Top = 458;  Label36->Top = 458;  Edit16->Top = 458;  Edit36->Top = 458;
    Label17->Top = 486;  Label37->Top = 486;  Edit17->Top = 486;  Edit37->Top = 486;
    Label18->Top = 514;  Label38->Top = 514;  Edit18->Top = 514;  Edit38->Top = 514;
    Label19->Top = 542;  Label39->Top = 542;  Edit19->Top = 542;  Edit39->Top = 542;
    Label20->Top = 570;  Label40->Top = 570;  Edit20->Top = 570;  Edit40->Top = 570;
                         Label41->Top = 598;                      Edit41->Top = 598;
                         Label42->Top = 598;                      Edit42->Top = 598;

    Label1->Left = 24; Label2->Left = 24; Label3->Left = 24; Label4->Left = 24; Label5->Left = 24; Label6->Left = 24; Label7->Left = 24; Label8->Left = 24; Label9->Left = 24; Label10->Left = 24; 
    Label11->Left = 24; Label12->Left = 24; Label13->Left = 24; Label14->Left = 24; Label15->Left = 24; Label16->Left = 24; Label17->Left = 24; Label18->Left = 24; Label19->Left = 24; Label20->Left = 24;
    Label21->Left = 158; Label22->Left = 158; Label23->Left = 158; Label24->Left = 158; Label25->Left = 158; Label26->Left = 158; Label27->Left = 158; Label28->Left = 158; Label29->Left = 158; Label30->Left = 158;
    Label31->Left = 158; Label32->Left = 158; Label33->Left = 158; Label34->Left = 158; Label35->Left = 158; Label36->Left = 158; Label37->Left = 158; Label38->Left = 158; Label39->Left = 158; Label40->Left = 158;
    Label41->Left = 158; Label42->Left = 24;
    Edit1->Left = 88; Edit2->Left = 88; Edit3->Left = 88; Edit4->Left = 88; Edit5->Left = 88; Edit6->Left = 88; Edit7->Left = 88; Edit8->Left = 88; Edit9->Left = 88; Edit10->Left = 88;
    Edit11->Left = 88; Edit12->Left = 88; Edit13->Left = 88; Edit14->Left = 88; Edit15->Left = 88; Edit16->Left = 88; Edit17->Left = 88; Edit18->Left = 88; Edit19->Left = 88; Edit20->Left = 88;
    Edit21->Left = 222; Edit22->Left = 222; Edit23->Left = 222; Edit24->Left = 222; Edit25->Left = 222; Edit26->Left = 222; Edit27->Left = 222; Edit28->Left = 222; Edit29->Left = 222; Edit30->Left = 222;
    Edit31->Left = 222; Edit32->Left = 222; Edit33->Left = 222; Edit34->Left = 222; Edit35->Left = 222; Edit36->Left = 222; Edit37->Left = 222; Edit38->Left = 222; Edit39->Left = 222; Edit40->Left = 222;
    Edit41->Left = 222; Edit42->Left = 88;
    Label1->Width = 56; Label2->Width = 56; Label3->Width = 56; Label4->Width = 56; Label5->Width = 56; Label6->Width = 56; Label7->Width = 56; Label8->Width = 56; Label9->Width = 56; Label10->Width = 56;
    Label11->Width = 56; Label12->Width = 56; Label13->Width = 56; Label14->Width = 56; Label15->Width = 56; Label16->Width = 56; Label17->Width = 56; Label18->Width = 56; Label19->Width = 56; Label20->Width = 56;
    Label21->Width = 56; Label22->Width = 56; Label23->Width = 56; Label24->Width = 56; Label25->Width = 56; Label26->Width = 56; Label27->Width = 56; Label28->Width = 56; Label29->Width = 56; Label30->Width = 56;
    Label31->Width = 56; Label32->Width = 56; Label33->Width = 56; Label34->Width = 56; Label35->Width = 56; Label36->Width = 56; Label37->Width = 56; Label38->Width = 56; Label39->Width = 56; Label40->Width = 56;
    Label41->Width = 56; Label42->Width = 56; 
    Edit1->Width = 56; Edit2->Width = 56; Edit3->Width = 56; Edit4->Width = 56; Edit5->Width = 56; Edit6->Width = 56; Edit7->Width = 56; Edit8->Width = 56; Edit9->Width = 56; Edit10->Width = 56; 
    Edit11->Width = 56;  Edit12->Width = 56; Edit13->Width = 56; Edit14->Width = 56; Edit15->Width = 56; Edit16->Width = 56; Edit17->Width = 56; Edit18->Width = 56; Edit19->Width = 56; Edit20->Width = 56;
    Edit21->Width = 56; Edit22->Width = 56; Edit23->Width = 56; Edit24->Width = 56; Edit25->Width = 56; Edit26->Width = 56; Edit27->Width = 56; Edit28->Width = 56; Edit29->Width = 56; Edit30->Width = 56;
    Edit31->Width = 56; Edit32->Width = 56; Edit33->Width = 56; Edit34->Width = 56; Edit35->Width = 56; Edit36->Width = 56; Edit37->Width = 56; Edit38->Width = 56; Edit39->Width = 56; Edit40->Width = 56;
    Edit41->Width = 56; Edit42->Width = 56; 
    Label1->Height = 20; Label2->Height = 20; Label3->Height = 20; Label4->Height = 20; Label5->Height = 20; Label6->Height = 20; Label7->Height = 20; Label8->Height = 20; Label9->Height = 20; Label10->Height = 20;
    Label11->Height = 20; Label12->Height = 20; Label13->Height = 20; Label14->Height = 20; Label15->Height = 20; Label16->Height = 20; Label17->Height = 20; Label18->Height = 20; Label19->Height = 20; Label20->Height = 20;
    Label21->Height = 20; Label22->Height = 20; Label23->Height = 20; Label24->Height = 20; Label25->Height = 20; Label26->Height = 20; Label27->Height = 20; Label28->Height = 20; Label29->Height = 20; Label30->Height = 20;
    Label31->Height = 20; Label32->Height = 20; Label33->Height = 20; Label34->Height = 20; Label35->Height = 20; Label36->Height = 20; Label37->Height = 20; Label38->Height = 20; Label39->Height = 20; Label40->Height = 20;
    Label41->Height = 20; Label42->Height = 20;
    Edit1->Height = 20; Edit2->Height = 20; Edit3->Height = 20; Edit4->Height = 20; Edit5->Height = 20; Edit6->Height = 20; Edit7->Height = 20; Edit8->Height = 20; Edit9->Height = 20; Edit10->Height = 20;
    Edit11->Height = 20; Edit12->Height = 20; Edit13->Height = 20; Edit14->Height = 20; Edit15->Height = 20; Edit16->Height = 20; Edit17->Height = 20; Edit18->Height = 20; Edit19->Height = 20; Edit20->Height = 20;
    Edit21->Height = 20; Edit22->Height = 20; Edit23->Height = 20; Edit24->Height = 20; Edit25->Height = 20; Edit26->Height = 20; Edit27->Height = 20; Edit28->Height = 20; Edit29->Height = 20; Edit30->Height = 20;
    Edit31->Height = 20; Edit32->Height = 20; Edit33->Height = 20; Edit34->Height = 20; Edit35->Height = 20; Edit36->Height = 20; Edit37->Height = 20; Edit38->Height = 20; Edit39->Height = 20; Edit40->Height = 20;
    Edit41->Height = 20; Edit42->Height = 20;

    Label1->Caption = "01";   Label21->Caption = "21";
    Label2->Caption = "02";   Label22->Caption = "22";
    Label3->Caption = "03";   Label23->Caption = "23";
    Label4->Caption = "04";   Label24->Caption = "24";
    Label5->Caption = "05";   Label25->Caption = "25";
    Label6->Caption = "06";   Label26->Caption = "26";
    Label7->Caption = "07";   Label27->Caption = "27";
    Label8->Caption = "08";   Label28->Caption = "28";
    Label9->Caption = "09";   Label29->Caption = "29";
    Label10->Caption = "10";  Label30->Caption = "30";
    Label11->Caption = "11";  Label31->Caption = "31";
    Label12->Caption = "12";  Label32->Caption = "32";
    Label13->Caption = "13";  Label33->Caption = "33";
    Label14->Caption = "14";  Label34->Caption = "34";
    Label15->Caption = "15";  Label35->Caption = "35";
    Label16->Caption = "16";  Label36->Caption = "36";
    Label17->Caption = "17";  Label37->Caption = "37";
    Label18->Caption = "18";  Label38->Caption = "From";
    Label19->Caption = "19";  Label39->Caption = "Log";
    Label20->Caption = "20";  Label40->Caption = "Repeat";
                              Label41->Caption = "Setting";
    Label42->Caption = ""; Label42->AutoSize = false; Label42->Alignment = taRightJustify;

    decrement_by_n = kunCode->decrement_by_n;
    grouping = kunCode->grouping;
    mapping = kunCode->mapping;
    session = 0;
    weight = kunCode->weight;

// Reading a CSV file to produce KOPIC_CSV
    if(! readCsv(KOPIC_CSV, kunCode) ) {
        ofstream file(ERROR_TEXT);
        file << "Weight: NO_CSV" << endl;
    }

    textFields();
}

void __fastcall TOKRightDlg1::OKBtnClick(TObject *Sender)
{
    using namespace std;

    char *stop;
    const int DECIMAL = 10;
    int f;
    f = (int)strtol( Edit1->Text.c_str(), &stop, DECIMAL); field[1] = f >= 0 ? f : 0;
    f = (int)strtol( Edit2->Text.c_str(), &stop, DECIMAL); field[2] = f >= 0 ? f : 0;
    f = (int)strtol( Edit3->Text.c_str(), &stop, DECIMAL); field[3] = f >= 0 ? f : 0;
    f = (int)strtol( Edit4->Text.c_str(), &stop, DECIMAL); field[4] = f >= 0 ? f : 0;
    f = (int)strtol( Edit5->Text.c_str(), &stop, DECIMAL); field[5] = f >= 0 ? f : 0;
    f = (int)strtol( Edit6->Text.c_str(), &stop, DECIMAL); field[6] = f >= 0 ? f : 0;
    f = (int)strtol( Edit7->Text.c_str(), &stop, DECIMAL); field[7] = f >= 0 ? f : 0;
    f = (int)strtol( Edit8->Text.c_str(), &stop, DECIMAL); field[8] = f >= 0 ? f : 0;
    f = (int)strtol( Edit9->Text.c_str(), &stop, DECIMAL); field[9] = f >= 0 ? f : 0;
    f = (int)strtol( Edit10->Text.c_str(), &stop, DECIMAL); field[10] = f >= 0 ? f : 0;
    f = (int)strtol( Edit11->Text.c_str(), &stop, DECIMAL); field[11] = f >= 0 ? f : 0;
    f = (int)strtol( Edit12->Text.c_str(), &stop, DECIMAL); field[12] = f >= 0 ? f : 0;
    f = (int)strtol( Edit13->Text.c_str(), &stop, DECIMAL); field[13] = f >= 0 ? f : 0;
    f = (int)strtol( Edit14->Text.c_str(), &stop, DECIMAL); field[14] = f >= 0 ? f : 0;
    f = (int)strtol( Edit15->Text.c_str(), &stop, DECIMAL); field[15] = f >= 0 ? f : 0;
    f = (int)strtol( Edit16->Text.c_str(), &stop, DECIMAL); field[16] = f >= 0 ? f : 0;
    f = (int)strtol( Edit17->Text.c_str(), &stop, DECIMAL); field[17] = f >= 0 ? f : 0;
    f = (int)strtol( Edit18->Text.c_str(), &stop, DECIMAL); field[18] = f >= 0 ? f : 0;
    f = (int)strtol( Edit19->Text.c_str(), &stop, DECIMAL); field[19] = f >= 0 ? f : 0;
    f = (int)strtol( Edit20->Text.c_str(), &stop, DECIMAL); field[20] = f >= 0 ? f : 0;
    f = (int)strtol( Edit21->Text.c_str(), &stop, DECIMAL); field[21] = f >= 0 ? f : 0;
    f = (int)strtol( Edit22->Text.c_str(), &stop, DECIMAL); field[22] = f >= 0 ? f : 0;
    f = (int)strtol( Edit23->Text.c_str(), &stop, DECIMAL); field[23] = f >= 0 ? f : 0;
    f = (int)strtol( Edit24->Text.c_str(), &stop, DECIMAL); field[24] = f >= 0 ? f : 0;
    f = (int)strtol( Edit25->Text.c_str(), &stop, DECIMAL); field[25] = f >= 0 ? f : 0;
    f = (int)strtol( Edit26->Text.c_str(), &stop, DECIMAL); field[26] = f >= 0 ? f : 0;
    f = (int)strtol( Edit27->Text.c_str(), &stop, DECIMAL); field[27] = f >= 0 ? f : 0;
    f = (int)strtol( Edit28->Text.c_str(), &stop, DECIMAL); field[28] = f >= 0 ? f : 0;
    f = (int)strtol( Edit29->Text.c_str(), &stop, DECIMAL); field[29] = f >= 0 ? f : 0;
    f = (int)strtol( Edit30->Text.c_str(), &stop, DECIMAL); field[30] = f >= 0 ? f : 0;
    f = (int)strtol( Edit31->Text.c_str(), &stop, DECIMAL); field[31] = f >= 0 ? f : 0;
    f = (int)strtol( Edit32->Text.c_str(), &stop, DECIMAL); field[32] = f >= 0 ? f : 0;
    f = (int)strtol( Edit33->Text.c_str(), &stop, DECIMAL); field[33] = f >= 0 ? f : 0;
    f = (int)strtol( Edit34->Text.c_str(), &stop, DECIMAL); field[34] = f >= 0 ? f : 0;
    f = (int)strtol( Edit35->Text.c_str(), &stop, DECIMAL); field[35] = f >= 0 ? f : 0;
    f = (int)strtol( Edit36->Text.c_str(), &stop, DECIMAL); field[36] = f >= 0 ? f : 0;
    f = (int)strtol( Edit37->Text.c_str(), &stop, DECIMAL); field[37] = f >= 0 ? f : 0;
    f = (int)strtol( Edit38->Text.c_str(), &stop, DECIMAL); field[38] = f >= 0 ? f : 400;
    field[39] = 0;
    f = (int)strtol( Edit40->Text.c_str(), &stop, DECIMAL); field[40] = f >= 0 ? f : 420;
    f = (int)strtol( Edit41->Text.c_str(), &stop, DECIMAL); field[41] = f >= 0 ? f : 123456;

    ofstream csv_file(KOPIC_CSV);
    if( csv_file.fail() ) {
        ofstream file(ERROR_TEXT);
        file << "ofstream csv_file(KOPIC_CSV)" << endl;
        return;
    }

    string b01("01,"); string b02("02,"); string b03("03,"); string b04("04,"); string b05("05,"); string b06("06,"); string b07("07,"); string b08("08,"); string b09("09,"); string b10("10,");
    string b11("11,"); string b12("12,"); string b13("13,"); string b14("14,"); string b15("15,"); string b16("16,"); string b17("17,"); string b18("18,"); string b19("19,"); string b20("20,");
    string b21("21,"); string b22("22,"); string b23("23,"); string b24("24,"); string b25("25,"); string b26("26,"); string b27("27,"); string b28("28,"); string b29("29,"); string b30("30,");
    string b31("31,"); string b32("32,"); string b33("33,"); string b34("34,"); string b35("35,"); string b36("36,"); string b37("37,");
    string EMPTY("");

    string d[ ALL + 1 ];
    d[0] = EMPTY;
    d[1] = b01; d[2] = b02; d[3] = b03; d[4] = b04; d[5] = b05; d[6] = b06; d[7] = b07; d[8] = b08; d[9] = b09; d[10] = b10;
    d[11] = b11; d[12] = b12; d[13] = b13; d[14] = b14; d[15] = b15; d[16] = b16; d[17] = b17; d[18] = b18; d[19] = b19; d[20] = b20;
    d[21] = b21; d[22] = b22; d[23] = b23; d[24] = b24; d[25] = b25; d[26] = b26; d[27] = b27; d[28] = b28; d[29] = b29; d[30] = b30;
    d[31] = b31; d[32] = b32; d[33] = b33; d[34] = b34; d[35] = b35; d[36] = b36; d[37] = b37;

    for(int line = 1; line <= ALL; line += 1 ) {
        csv_file << d[line] << field[line] << endl;
    }

    csv_file << "From," << field[FROM_LINE] << endl 
        << "Log," << Edit39->Text.c_str() << endl
        << "Repeat," << field[REPEAT_LINE] << endl 
        << "Setting," << field[SETTING_LINE] << endl;

    csv_file.close();
    untouched = modified_file(KOPIC_CSV);

    KUN_CODE kc;
    kc.defectiveCsv = false;
    kc.full_swing = false;
    kc.grouping = grouping;
    kc.mapping = mapping;
    kc.weight = weight;
    PICK_CODE pc = kopicLog(KOPIC_CSV, &kc);
    Form1->temporaryFileName(pc.temporary_file_name);

    string file_name(pc.temporary_file_name);
    Form1->header(file_name);
}

void __fastcall TOKRightDlg1::Label42Click(TObject *Sender)
{
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;

    session += 1;
    int phase = session%3; // 0, 1, 2

    switch (phase) {
    case 0:
        Label42->Caption = "MT";
        mm->prng = MERSENNE_TWISTER;
        break;
    case 1:
        Label42->Caption = "xorshift";
        mm->prng = XORSHIFT;
        break;
    default:
        Label42->Caption = "";
        mm->prng = MERSENNE_TWISTER;
        break;
    }

}
